<?php
error_reporting(0);
/**
 * Plugin Name: Shipping Mipaquete Woocommerce
 * Description: Genera los envíos de tu tienda virtual en woocommerce de forma automatizada. Selecciona tu transportadora de preferencia o por criterio (precio, tiempo de entrega o calificación del servicio). Logra trazabilidad de todos tus envíos y solución de novedades en una sola plataforma. Todo esto gratis, solo pagas por tus envíos. Si tienes dudas, contáctanos al whatsapp +573216330447
 * Version: 3.1.0
 * Author: mipaquete.com
 * Author URI: https://mipaquete.com
 * License: GNU General Public License v3.0
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 * WC tested up to: 3.6
 * WC requires at least: 2.6
 */



if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    include('config.php');
    add_filter('woocommerce_checkout_fields','njengah_override_checkout_fields');
    function njengah_override_checkout_fields( $fields ) {
        unset($fields['billing']['billing_country']);
        unset($fields['billing']['billing_state']);
        unset($fields['shipping']['shipping_country']);
        unset($fields['shipping']['shipping_state']);
        return $fields;
    }
    add_action('woocommerce_product_options_general_product_data', 'woocommerce_product_custom_fields_mipaquete');
    // Save Fields
    add_action('woocommerce_process_product_meta', 'woocommerce_product_custom_fields_save');
    function woocommerce_product_custom_fields_mipaquete()
    {
        global $woocommerce;
        echo '<div class="product_custom_field">';
        //Custom Product Number Field
        woocommerce_wp_text_input(
            array(
                'id' => '_custom_product_number_field_mipaquete',
                'placeholder' => 'Valor declarado del producto',
                'label' => __('Valor declarado del producto', 'woocommerce'),
                'type' => 'number',
                'description' => __('Recuerda que en caso de pérdida o necesidad de indemnización, el proceso se realizará sobre el valor que haya indicado aquí además del soporte de tu factura.'),
                'desc_tip' => true,
                'custom_attributes' => array(
                    'step' => 'any',
                    'min' => '1000'
                )
            )
        );
        echo '</div>';
        echo "Actualmente el valor declarado es: <b>" . get_post_meta(get_the_ID(), '_custom_product_number_field_mipaquete', true) . "</b>";
    }
    function woocommerce_product_custom_fields_save($post_id)
    {
    // Custom Product Number Field
        $woocommerce_custom_product_number_field_mipaquete = $_POST['_custom_product_number_field_mipaquete'];
        if (!empty($woocommerce_custom_product_number_field_mipaquete))
            update_post_meta($post_id, '_custom_product_number_field_mipaquete', esc_attr($woocommerce_custom_product_number_field_mipaquete));
    }
    // Copy from here

    /**
     * Change the checkout city field to a dropdown field.
     */
    function mipaquete_change_city_customer( $fields ) {
        $city_args = wp_parse_args( array(
            'type' => 'select',
            'options' => array(
                'SELECCIONE LA CIUDAD'  =>  'SELECCIONE LA CIUDAD',
                '70742000'  => 'SAN LUIS DE SINCÉ-SUCRE',
                '70204000'  => 'COLOSO-SUCRE',
                '08001000'  => 'BARRANQUILLA-ATLÁNTICO',
                '91001000'  => 'LETICIA-AMAZONAS',
                '91540000'  => 'PUERTO NARIÑO-AMAZONAS',
                '05591004'  => 'DORADAL-ANTIOQUIA',
                '05030000'  => 'AMAGÁ-ANTIOQUIA',
                '05034000'  => 'ANDES-ANTIOQUIA',
                '05059000'  => 'ARMENIA-ANTIOQUIA',
                '05079000'  => 'BARBOSA-ANTIOQUIA',
                '05088000'  => 'BELLO-ANTIOQUIA',
                '05129000'  => 'CALDAS-ANTIOQUIA',
                '05212000'  => 'COPACABANA-ANTIOQUIA',
                '05148000'  => 'EL CARMEN DE VIBORAL-ANTIOQUIA',
                '05266000'  => 'ENVIGADO-ANTIOQUIA',
                '05318000'  => 'GUARNE-ANTIOQUIA',
                '05360000'  => 'ITAGUI-ANTIOQUIA',
                '05380000'  => 'LA ESTRELLA-ANTIOQUIA',
                '05615000'  => 'RIONEGRO-ANTIOQUIA',
                '05631000'  => 'SABANETA-ANTIOQUIA',
                '05664000'  => 'SAN PEDRO-ANTIOQUIA',
                '05679000'  => 'SANTA BÁRBARA-ANTIOQUIA',
                '05756000'  => 'SONSÓN-ANTIOQUIA',
                '05789000'  => 'TÁMESIS-ANTIOQUIA',
                '05847000'  => 'URRAO-ANTIOQUIA',
                '05885000'  => 'YALÍ-ANTIOQUIA',
                '05887000'  => 'YARUMAL-ANTIOQUIA',
                '05093000'  => 'BETULIA-ANTIOQUIA',
                '05234000'  => 'DABEIBA-ANTIOQUIA',
                '05250000'  => 'EL BAGRE-ANTIOQUIA',
                '05310000'  => 'GÓMEZ PLATA-ANTIOQUIA',
                '05313000'  => 'GRANADA-ANTIOQUIA',
                '05400000'  => 'LA UNIÓN-ANTIOQUIA',
                '05001000'  => 'MEDELLÍN-ANTIOQUIA',
                '05628000'  => 'SABANALARGA-ANTIOQUIA',
                '05670000'  => 'SAN ROQUE-ANTIOQUIA',
                '05736000'  => 'SEGOVIA-ANTIOQUIA',
                '05761000'  => 'SOPETRÁN-ANTIOQUIA',
                '05792000'  => 'TARSO-ANTIOQUIA',
                '05809000'  => 'TITIRIBÍ-ANTIOQUIA',
                '05854000'  => 'VALDIVIA-ANTIOQUIA',
                '05856000'  => 'VALPARAÍSO-ANTIOQUIA',
                '05858000'  => 'VEGACHÍ-ANTIOQUIA',
                '05861000'  => 'VENECIA-ANTIOQUIA',
                '05890000'  => 'YOLOMBÓ-ANTIOQUIA',
                '05002000'  => 'ABEJORRAL-ANTIOQUIA',
                '05004000'  => 'ABRIAQUÍ-ANTIOQUIA',
                '05021000'  => 'ALEJANDRÍA-ANTIOQUIA',
                '05031000'  => 'AMALFI-ANTIOQUIA',
                '05036000'  => 'ANGELÓPOLIS-ANTIOQUIA',
                '05038000'  => 'ANGOSTURA-ANTIOQUIA',
                '05040000'  => 'ANORÍ-ANTIOQUIA',
                '05044000'  => 'ANZA-ANTIOQUIA',
                '05045000'  => 'APARTADÓ-ANTIOQUIA',
                '05051000'  => 'ARBOLETES-ANTIOQUIA',
                '05055000'  => 'ARGELIA-ANTIOQUIA',
                '05086000'  => 'BELMIRA-ANTIOQUIA',
                '05091000'  => 'BETANIA-ANTIOQUIA',
                '05107000'  => 'BRICEÑO-ANTIOQUIA',
                '05113000'  => 'BURITICÁ-ANTIOQUIA',
                '05120000'  => 'CÁCERES-ANTIOQUIA',
                '05125000'  => 'CAICEDO-ANTIOQUIA',
                '05134000'  => 'CAMPAMENTO-ANTIOQUIA',
                '05138000'  => 'CAÑASGORDAS-ANTIOQUIA',
                '05142000'  => 'CARACOLÍ-ANTIOQUIA',
                '05145000'  => 'CARAMANTA-ANTIOQUIA',
                '05147000'  => 'CAREPA-ANTIOQUIA',
                '05150000'  => 'CAROLINA-ANTIOQUIA',
                '05154000'  => 'CAUCASIA-ANTIOQUIA',
                '05172000'  => 'CHIGORODÓ-ANTIOQUIA',
                '05190000'  => 'CISNEROS-ANTIOQUIA',
                '05101000'  => 'CIUDAD BOLÍVAR-ANTIOQUIA',
                '05197000'  => 'COCORNÁ-ANTIOQUIA',
                '05206000'  => 'CONCEPCIÓN-ANTIOQUIA',
                '05209000'  => 'CONCORDIA-ANTIOQUIA',
                '05237000'  => 'DON MATÍAS-ANTIOQUIA',
                '05240000'  => 'EBÉJICO-ANTIOQUIA',
                '05697000'  => 'EL SANTUARIO-ANTIOQUIA',
                '05264000'  => 'ENTRERRIOS-ANTIOQUIA',
                '05282000'  => 'FREDONIA-ANTIOQUIA',
                '05284000'  => 'FRONTINO-ANTIOQUIA',
                '05306000'  => 'GIRALDO-ANTIOQUIA',
                '05308000'  => 'GIRARDOTA-ANTIOQUIA',
                '05315000'  => 'GUADALUPE-ANTIOQUIA',
                '05321000'  => 'GUATAPÉ-ANTIOQUIA',
                '05347000'  => 'HELICONIA-ANTIOQUIA',
                '05353000'  => 'HISPANIA-ANTIOQUIA',
                '05361000'  => 'ITUANGO-ANTIOQUIA',
                '05364000'  => 'JARDÍN-ANTIOQUIA',
                '05368000'  => 'JERICÓ-ANTIOQUIA',
                '05376000'  => 'LA CEJA-ANTIOQUIA',
                '05390000'  => 'LA PINTADA-ANTIOQUIA',
                '05411000'  => 'LIBORINA-ANTIOQUIA',
                '05425000'  => 'MACEO-ANTIOQUIA',
                '05440000'  => 'MARINILLA-ANTIOQUIA',
                '05467000'  => 'MONTEBELLO-ANTIOQUIA',
                '05475000'  => 'MURINDÓ-ANTIOQUIA',
                '05480000'  => 'MUTATÁ-ANTIOQUIA',
                '05483000'  => 'NARIÑO-ANTIOQUIA',
                '05495000'  => 'NECHÍ-ANTIOQUIA',
                '05490000'  => 'NECOCLÍ-ANTIOQUIA',
                '05501000'  => 'OLAYA-ANTIOQUIA',
                '05541000'  => 'PEÑOL-ANTIOQUIA',
                '05543000'  => 'PEQUE-ANTIOQUIA',
                '05576000'  => 'PUEBLORRICO-ANTIOQUIA',
                '05579000'  => 'PUERTO BERRÍO-ANTIOQUIA',
                '05585000'  => 'PUERTO NARE-ANTIOQUIA',
                '05591000'  => 'PUERTO TRIUNFO-ANTIOQUIA',
                '05604000'  => 'REMEDIOS-ANTIOQUIA',
                '05607000'  => 'RETIRO-ANTIOQUIA',
                '05642000'  => 'SALGAR-ANTIOQUIA',
                '05647000'  => 'SAN ANDRÉS DE CUERQUÍA-ANTIOQUIA',
                '05649000'  => 'SAN CARLOS-ANTIOQUIA',
                '05652000'  => 'SAN FRANCISCO-ANTIOQUIA',
                '05656000'  => 'SAN JERÓNIMO-ANTIOQUIA',
                '05658000'  => 'SAN JOSÉ DE LA MONTAÑA-ANTIOQUIA',
                '05659000'  => 'SAN JUAN DE URABÁ-ANTIOQUIA',
                '05660000'  => 'SAN LUIS-ANTIOQUIA',
                '05665000'  => 'SAN PEDRO DE URABA-ANTIOQUIA',
                '05667000'  => 'SAN RAFAEL-ANTIOQUIA',
                '05674000'  => 'SAN VICENTE-ANTIOQUIA',
                '05686000'  => 'SANTA ROSA DE OSOS-ANTIOQUIA',
                '05042000'  => 'SANTAFÉ DE ANTIOQUIA-ANTIOQUIA',
                '05690000'  => 'SANTO DOMINGO-ANTIOQUIA',
                '05790000'  => 'TARAZÁ-ANTIOQUIA',
                '05819000'  => 'TOLEDO-ANTIOQUIA',
                '05837000'  => 'TURBO-ANTIOQUIA',
                '05842000'  => 'URAMITA-ANTIOQUIA',
                '05873000'  => 'VIGÍA DEL FUERTE-ANTIOQUIA',
                '05895000'  => 'ZARAGOZA-ANTIOQUIA',
                '05893000'  => 'YONDÓ-ANTIOQUIA',
                '05819002'  => 'EL VALLE-ANTIOQUIA',
                '05837002'  => 'NUEVA COLONIA-ANTIOQUIA',
                '05250002'  => 'PUERTO CLAVER-ANTIOQUIA',
                '05591002'  => 'PUERTO PERALES NUEVO-ANTIOQUIA',
                '05837001'  => 'CURRULAO-ANTIOQUIA',
                '05585003'  => 'LA SIERRA-ANTIOQUIA',
                '05789001'  => 'PALERMO-ANTIOQUIA',
                '81001000'  => 'ARAUCA-ARAUCA',
                '81065000'  => 'ARAUQUITA-ARAUCA',
                '81220000'  => 'CRAVO NORTE-ARAUCA',
                '81300000'  => 'FORTUL-ARAUCA',
                '81591000'  => 'PUERTO RONDÓN-ARAUCA',
                '81736000'  => 'SARAVENA-ARAUCA',
                '81794000'  => 'TAME-ARAUCA',
                '08573000'  => 'PUERTO COLOMBIA-ATLÁNTICO',
                '08638000'  => 'SABANALARGA-ATLÁNTICO',
                '08758000'  => 'SOLEDAD-ATLÁNTICO',
                '08078000'  => 'BARANOA-ATLÁNTICO',
                '08137000'  => 'CAMPO DE LA CRUZ-ATLÁNTICO',
                '08141000'  => 'CANDELARIA-ATLÁNTICO',
                '08296000'  => 'GALAPA-ATLÁNTICO',
                '08372000'  => 'JUAN DE ACOSTA-ATLÁNTICO',
                '08421000'  => 'LURUACO-ATLÁNTICO',
                '08433000'  => 'MALAMBO-ATLÁNTICO',
                '08436000'  => 'MANATÍ-ATLÁNTICO',
                '08520000'  => 'PALMAR DE VARELA-ATLÁNTICO',
                '08549000'  => 'PIOJÓ-ATLÁNTICO',
                '08558000'  => 'POLONUEVO-ATLÁNTICO',
                '08560000'  => 'PONEDERA-ATLÁNTICO',
                '08606000'  => 'REPELÓN-ATLÁNTICO',
                '08634000'  => 'SABANAGRANDE-ATLÁNTICO',
                '08675000'  => 'SANTA LUCÍA-ATLÁNTICO',
                '08685000'  => 'SANTO TOMÁS-ATLÁNTICO',
                '08770000'  => 'SUAN-ATLÁNTICO',
                '08832000'  => 'TUBARÁ-ATLÁNTICO',
                '08849000'  => 'USIACURÍ-ATLÁNTICO',
                '08638001'  => 'AGUADA DE PABLO-ATLÁNTICO',
                '08078001'  => 'CAMPECHE-ATLÁNTICO',
                '13430006'  => 'CASCAJAL-BOLÍVAR',
                '13430006'  => 'CASCAJAL-BOLÍVAR',
                '08560003'  => 'PUERTO GIRALDO-ATLÁNTICO',
                '08421005'  => 'SANTA CRUZ-ATLÁNTICO',
                '08433001'  => 'CARACOLÍ-ATLÁNTICO',
                '08638005'  => 'LA PEÑA-ATLÁNTICO',
                '11001000'  => 'BOGOTÁ D.C.-BOGOTÁ D.C.',
                '13001000'  => 'CARTAGENA-BOLÍVAR',
                '13468000'  => 'MOMPÓS-BOLÍVAR',
                '13683000'  => 'SANTA ROSA-BOLÍVAR',
                '13873000'  => 'VILLANUEVA-BOLÍVAR',
                '13810000'  => 'PUERTO RICO-BOLÍVAR',
                '13810000'  => 'PUERTO RICO-BOLÍVAR',
                '13442008'  => 'SAN PABLO-BOLÍVAR',
                '13006000'  => 'ACHÍ-BOLÍVAR',
                '13030000'  => 'ALTOS DEL ROSARIO-BOLÍVAR',
                '13042000'  => 'ARENAL-BOLÍVAR',
                '13052000'  => 'ARJONA-BOLÍVAR',
                '13062000'  => 'ARROYOHONDO-BOLÍVAR',
                '13074000'  => 'BARRANCO DE LOBA-BOLÍVAR',
                '13140000'  => 'CALAMAR-BOLÍVAR',
                '13160000'  => 'CANTAGALLO-BOLÍVAR',
                '13188000'  => 'CICUCO-BOLÍVAR',
                '13222000'  => 'CLEMENCIA-BOLÍVAR',
                '13212000'  => 'CÓRDOBA-BOLÍVAR',
                '13244000'  => 'EL CARMEN DE BOLÍVAR-BOLÍVAR',
                '13248000'  => 'EL GUAMO-BOLÍVAR',
                '13268000'  => 'EL PEÑÓN-BOLÍVAR',
                '13300000'  => 'HATILLO DE LOBA-BOLÍVAR',
                '13430000'  => 'MAGANGUÉ-BOLÍVAR',
                '13433000'  => 'MAHATES-BOLÍVAR',
                '13440000'  => 'MARGARITA-BOLÍVAR',
                '13442000'  => 'MARÍA LA BAJA-BOLÍVAR',
                '13458000'  => 'MONTECRISTO-BOLÍVAR',
                '13473000'  => 'MORALES-BOLÍVAR',
                '13490000'  => 'NOROSÍ-BOLÍVAR',
                '13549000'  => 'PINILLOS-BOLÍVAR',
                '13580000'  => 'REGIDOR-BOLÍVAR',
                '13600000'  => 'RÍO VIEJO-BOLÍVAR',
                '13620000'  => 'SAN CRISTÓBAL-BOLÍVAR',
                '13647000'  => 'SAN ESTANISLAO-BOLÍVAR',
                '13650000'  => 'SAN FERNANDO-BOLÍVAR',
                '13654000'  => 'SAN JACINTO-BOLÍVAR',
                '13655000'  => 'SAN JACINTO DEL CAUCA-BOLÍVAR',
                '13657000'  => 'SAN JUAN NEPOMUCENO-BOLÍVAR',
                '13667000'  => 'SAN MARTÍN DE LOBA-BOLÍVAR',
                '13667000'  => 'SAN MARTÍN DE LOBA-BOLÍVAR',
                '13673000'  => 'SANTA CATALINA-BOLÍVAR',
                '13688000'  => 'SANTA ROSA DEL SUR-BOLÍVAR',
                '13744000'  => 'SIMITÍ-BOLÍVAR',
                '13760000'  => 'SOPLAVIENTO-BOLÍVAR',
                '13780000'  => 'TALAIGUA NUEVO-BOLÍVAR',
                '13810011'  => 'TIQUISIO-BOLÍVAR',
                '13836000'  => 'TURBACO-BOLÍVAR',
                '13838000'  => 'TURBANÁ-BOLÍVAR',
                '13894000'  => 'ZAMBRANO-BOLÍVAR',
                '13001004'  => 'BAYUNCA-BOLÍVAR',
                '13052002'  => 'GAMBOTE-BOLÍVAR',
                '13430013'  => 'JUAN ARIAS-BOLÍVAR',
                '13433003'  => 'MALAGANA-BOLÍVAR',
                '13001009'  => 'PASACABALLOS-BOLÍVAR',
                '13001020'  => 'PONTEZUELA-BOLÍVAR',
                '13430048'  => 'PUNTA DE CARTAGENA-BOLÍVAR',
                '13052004'  => 'SINCERIN-BOLÍVAR',
                '13430011'  => 'HENEQUEN-BOLÍVAR',
                '13001012'  => 'SANTA ANA-BOLÍVAR',
                '15047000'  => 'AQUITANIA-BOYACÁ',
                '15051000'  => 'ARCABUCO-BOYACÁ',
                '15087000'  => 'BELÉN-BOYACÁ',
                '15090000'  => 'BERBEO-BOYACÁ',
                '15097000'  => 'BOAVITA-BOYACÁ',
                '15109000'  => 'BUENA VISTA-BOYACÁ',
                '15162000'  => 'CERINZA-BOYACÁ',
                '15172000'  => 'CHINAVITA-BOYACÁ',
                '15176000'  => 'CHIQUINQUIRÁ-BOYACÁ',
                '15187000'  => 'CHIVATÁ-BOYACÁ',
                '15236000'  => 'CHIVOR-BOYACÁ',
                '15189000'  => 'CIÉNEGA-BOYACÁ',
                '15204000'  => 'CÓMBITA-BOYACÁ',
                '15212000'  => 'COPER-BOYACÁ',
                '15224000'  => 'CUCAITA-BOYACÁ',
                '15238000'  => 'DUITAMA-BOYACÁ',
                '15244000'  => 'EL COCUY-BOYACÁ',
                '15248000'  => 'EL ESPINO-BOYACÁ',
                '15272000'  => 'FIRAVITOBA-BOYACÁ',
                '15299000'  => 'GARAGOA-BOYACÁ',
                '15322000'  => 'GUATEQUE-BOYACÁ',
                '15325000'  => 'GUAYATÁ-BOYACÁ',
                '15332000'  => 'GÜICÁN-BOYACÁ',
                '15367000'  => 'JENESANO-BOYACÁ',
                '15455000'  => 'MIRAFLORES-BOYACÁ',
                '15466000'  => 'MONGUÍ-BOYACÁ',
                '15469000'  => 'MONIQUIRÁ-BOYACÁ',
                '15480000'  => 'MUZO-BOYACÁ',
                '15491000'  => 'NOBSA-BOYACÁ',
                '15500000'  => 'OICATÁ-BOYACÁ',
                '15507000'  => 'OTANCHE-BOYACÁ',
                '15511000'  => 'PACHAVITA-BOYACÁ',
                '15514000'  => 'PÁEZ-BOYACÁ',
                '15516000'  => 'PAIPA-BOYACÁ',
                '15531000'  => 'PAUNA-BOYACÁ',
                '15537000'  => 'PAZ DE RÍO-BOYACÁ',
                '15542000'  => 'PESCA-BOYACÁ',
                '15572000'  => 'PUERTO BOYACÁ-BOYACÁ',
                '15580000'  => 'QUÍPAMA-BOYACÁ',
                '15599000'  => 'RAMIRIQUÍ-BOYACÁ',
                '15600000'  => 'RÁQUIRA-BOYACÁ',
                '15632000'  => 'SABOYÁ-BOYACÁ',
                '15638000'  => 'SÁCHICA-BOYACÁ',
                '15646000'  => 'SAMACÁ-BOYACÁ',
                '15664000'  => 'SAN JOSÉ DE PARE-BOYACÁ',
                '15667000'  => 'SAN LUIS DE GACENO-BOYACÁ',
                '15673000'  => 'SAN MATEO-BOYACÁ',
                '15757000'  => 'SOCHA-BOYACÁ',
                '15690000'  => 'SANTA MARÍA-BOYACÁ',
                '15693000'  => 'SANTA ROSA DE VITERBO-BOYACÁ',
                '15686000'  => 'SANTANA-BOYACÁ',
                '15740000'  => 'SIACHOQUE-BOYACÁ',
                '15753000'  => 'SOATÁ-BOYACÁ',
                '15755000'  => 'SOCOTÁ-BOYACÁ',
                '15759000'  => 'SOGAMOSO-BOYACÁ',
                '15761000'  => 'SOMONDOCO-BOYACÁ',
                '15764000'  => 'SORACÁ-BOYACÁ',
                '15763000'  => 'SOTAQUIRÁ-BOYACÁ',
                '15776000'  => 'SUTAMARCHÁN-BOYACÁ',
                '15798000'  => 'TENZA-BOYACÁ',
                '15804000'  => 'TIBANÁ-BOYACÁ',
                '15806000'  => 'TIBASOSA-BOYACÁ',
                '15810000'  => 'TIPACOQUE-BOYACÁ',
                '15814000'  => 'TOCA-BOYACÁ',
                '15820000'  => 'TÓPAGA-BOYACÁ',
                '15001000'  => 'TUNJA-BOYACÁ',
                '15835000'  => 'TURMEQUÉ-BOYACÁ',
                '15837000'  => 'TUTA-BOYACÁ',
                '15842000'  => 'UMBITA-BOYACÁ',
                '15861000'  => 'VENTAQUEMADA-BOYACÁ',
                '15407000'  => 'VILLA DE LEYVA-BOYACÁ',
                '15897000'  => 'ZETAQUIRA-BOYACÁ',
                '15681005'  => 'SANTA BÁRBARA-BOYACÁ',
                '15131000'  => 'CALDAS-BOYACÁ',
                '15022000'  => 'ALMEIDA-BOYACÁ',
                '15092000'  => 'BETÉITIVA-BOYACÁ',
                '15104000'  => 'BOYACÁ-BOYACÁ',
                '15114000'  => 'BUSBANZÁ-BOYACÁ',
                '15135000'  => 'CAMPOHERMOSO-BOYACÁ',
                '15232000'  => 'CHÍQUIZA-BOYACÁ',
                '15185000'  => 'CHITARAQUE-BOYACÁ',
                '15215000'  => 'CORRALES-BOYACÁ',
                '15218000'  => 'COVARACHÍA-BOYACÁ',
                '15223000'  => 'CUBARÁ-BOYACÁ',
                '15226000'  => 'CUÍTIVA-BOYACÁ',
                '15276000'  => 'FLORESTA-BOYACÁ',
                '15293000'  => 'GACHANTIVÁ-BOYACÁ',
                '15296000'  => 'GAMEZA-BOYACÁ',
                '15317000'  => 'GUACAMAYAS-BOYACÁ',
                '15362000'  => 'IZA-BOYACÁ',
                '15368000'  => 'JERICÓ-BOYACÁ',
                '15380000'  => 'LA CAPILLA-BOYACÁ',
                '15403000'  => 'LA UVITA-BOYACÁ',
                '15401000'  => 'LA VICTORIA-BOYACÁ',
                '15377000'  => 'LABRANZAGRANDE-BOYACÁ',
                '15425000'  => 'MACANAL-BOYACÁ',
                '15476000'  => 'MOTAVITA-BOYACÁ',
                '15533000'  => 'PAYA-BOYACÁ',
                '15550000'  => 'PISBA-BOYACÁ',
                '15621000'  => 'RONDÓN-BOYACÁ',
                '15660000'  => 'SAN EDUARDO-BOYACÁ',
                '15681000'  => 'SAN PABLO DE BORBUR-BOYACÁ',
                '15720000'  => 'SATIVANORTE-BOYACÁ',
                '15723000'  => 'SATIVASUR-BOYACÁ',
                '15762000'  => 'SORA-BOYACÁ',
                '15774000'  => 'SUSACÓN-BOYACÁ',
                '15778000'  => 'SUTATENZA-BOYACÁ',
                '15808000'  => 'TINJACÁ-BOYACÁ',
                '15816000'  => 'TOGÜÍ-BOYACÁ',
                '15822000'  => 'TOTA-BOYACÁ',
                '15832000'  => 'TUNUNGUÁ-BOYACÁ',
                '15839000'  => 'TUTAZÁ-BOYACÁ',
                '15879000'  => 'VIRACACHÁ-BOYACÁ',
                '15491001'  => 'BELENCITO-BOYACÁ',
                '15106000'  => 'BRICEÑO (B)-BOYACÁ',
                '15106000'  => 'BRICEÑO (B)-BOYACÁ',
                '15238011'  => 'TRINIDAD-BOYACÁ',
                '17013000'  => 'AGUADAS-CALDAS',
                '17050000'  => 'ARANZAZU-CALDAS',
                '17272000'  => 'FILADELFIA-CALDAS',
                '17380000'  => 'LA DORADA-CALDAS',
                '17001000'  => 'MANIZALES-CALDAS',
                '17444000'  => 'MARQUETALIA-CALDAS',
                '17486000'  => 'NEIRA-CALDAS',
                '17495000'  => 'NORCASIA-CALDAS',
                '17513000'  => 'PÁCORA-CALDAS',
                '17653000'  => 'SALAMINA-CALDAS',
                '17662000'  => 'SAMANÁ-CALDAS',
                '17867000'  => 'VICTORIA-CALDAS',
                '17524001'  => 'ARAUCA-CALDAS',
                '17042000'  => 'ANSERMA-CALDAS',
                '17174000'  => 'CHINCHINÁ-CALDAS',
                '17388000'  => 'LA MERCED-CALDAS',
                '17433000'  => 'MANZANARES-CALDAS',
                '17442000'  => 'MARMATO-CALDAS',
                '17446000'  => 'MARULANDA-CALDAS',
                '17524000'  => 'PALESTINA-CALDAS',
                '17541000'  => 'PENSILVANIA-CALDAS',
                '17614000'  => 'RIOSUCIO-CALDAS',
                '17616000'  => 'RISARALDA-CALDAS',
                '17777000'  => 'SUPÍA-CALDAS',
                '17873000'  => 'VILLAMARÍA-CALDAS',
                '17877000'  => 'VITERBO-CALDAS',
                '17001010'  => 'ALTO TABLAZO-CALDAS',
                '17001003'  => 'BAJO TABLAZO-CALDAS',
                '17088000'  => 'BELALCAZAR (CL)-CALDAS',
                '17088000'  => 'BELALCAZAR (CL)-CALDAS',
                '17541002'  => 'BOLIVIA-CALDAS',
                '17380002'  => 'GUARINOCITO-CALDAS',
                '17541006'  => 'LA LINDA-CALDAS',
                '17665000'  => 'SAN JOSE (C)-CALDAS',
                '17665000'  => 'SAN JOSE (C)-CALDAS',
                '18150000'  => 'CARTAGENA DEL CHAIRÁ-CAQUETÁ',
                '18001000'  => 'FLORENCIA-CAQUETÁ',
                '18592000'  => 'PUERTO RICO-CAQUETÁ',
                '18753000'  => 'SAN VICENTE DEL CAGUÁN-CAQUETÁ',
                '18029000'  => 'ALBANIA-CAQUETÁ',
                '18860000'  => 'VALPARAÍSO-CAQUETÁ',
                '18094000'  => 'BELÉN DE LOS ANDAQUIES-CAQUETÁ',
                '18205000'  => 'CURILLO-CAQUETÁ',
                '18247000'  => 'EL DONCELLO-CAQUETÁ',
                '18256000'  => 'EL PAUJIL-CAQUETÁ',
                '18410000'  => 'LA MONTAÑITA-CAQUETÁ',
                '18460000'  => 'MILÁN-CAQUETÁ',
                '18479000'  => 'MORELIA-CAQUETÁ',
                '18610000'  => 'SAN JOSÉ DEL FRAGUA-CAQUETÁ',
                '18756000'  => 'SOLANO-CAQUETÁ',
                '18785000'  => 'SOLITA-CAQUETÁ',
                '18753004'  => 'CAMPOHERMOSO-CAQUETÁ',
                '85010000'  => 'AGUAZUL-CASANARE',
                '85162000'  => 'MONTERREY-CASANARE',
                '85250000'  => 'PAZ DE ARIPORO-CASANARE',
                '85263000'  => 'PORE-CASANARE',
                '85300000'  => 'SABANALARGA-CASANARE',
                '85410000'  => 'TAURAMENA-CASANARE',
                '85440000'  => 'VILLANUEVA-CASANARE',
                '85125000'  => 'HATO COROZAL-CASANARE',
                '85136000'  => 'LA SALINA-CASANARE',
                '85139000'  => 'MANÍ-CASANARE',
                '85279000'  => 'RECETOR-CASANARE',
                '85315000'  => 'SÁCAMA-CASANARE',
                '85430000'  => 'TRINIDAD-CASANARE',
                '85001000'  => 'YOPAL-CASANARE',
                '19290000'  => 'FLORENCIA-CAUCA',
                '19300000'  => 'GUACHENÉ-CAUCA',
                '19455000'  => 'MIRANDA-CAUCA',
                '19548000'  => 'PIENDAMÓ-CAUCA',
                '19001000'  => 'POPAYÁN-CAUCA',
                '19573000'  => 'PUERTO TEJADA-CAUCA',
                '19698000'  => 'SANTANDER DE QUILICHAO-CAUCA',
                '19532008'  => 'PATIA-CAUCA',
                '19001019'  => 'SANTA ROSA-CAUCA',
                '19455005'  => 'ORTIGAL-CAUCA',
                '19532000'  => 'EL BORDO-CAUCA',
                '19532000'  => 'EL BORDO-CAUCA',
                '19050006'  => 'EL PLATEADO-CAUCA',
                '19022000'  => 'ALMAGUER-CAUCA',
                '19050000'  => 'ARGELIA-CAUCA',
                '19075000'  => 'BALBOA-CAUCA',
                '19100000'  => 'BOLÍVAR-CAUCA',
                '19110000'  => 'BUENOS AIRES-CAUCA',
                '19130000'  => 'CAJIBÍO-CAUCA',
                '19137000'  => 'CALDONO-CAUCA',
                '19142000'  => 'CALOTO-CAUCA',
                '19256000'  => 'EL TAMBO-CAUCA',
                '19318000'  => 'GUAPI-CAUCA',
                '19355000'  => 'INZÁ-CAUCA',
                '19364000'  => 'JAMBALÓ-CAUCA',
                '19392000'  => 'LA SIERRA-CAUCA',
                '19392000'  => 'LA SIERRA-CAUCA',
                '19397000'  => 'LA VEGA-CAUCA',
                '19418000'  => 'LÓPEZ-CAUCA',
                '19450000'  => 'MERCADERES-CAUCA',
                '19473000'  => 'MORALES-CAUCA',
                '19513000'  => 'PADILLA-CAUCA',
                '19532008'  => 'PATÍA-CAUCA',
                '19533000'  => 'PIAMONTE-CAUCA',
                '19585004'  => 'PURACÉ-CAUCA',
                '19622000'  => 'ROSAS-CAUCA',
                '19693000'  => 'SAN SEBASTIÁN-CAUCA',
                '19743000'  => 'SILVIA-CAUCA',
                '19780000'  => 'SUÁREZ-CAUCA',
                '19785000'  => 'SUCRE-CAUCA',
                '19807000'  => 'TIMBÍO-CAUCA',
                '19809000'  => 'TIMBIQUÍ-CAUCA',
                '19821000'  => 'TORIBIO-CAUCA',
                '19824000'  => 'TOTORÓ-CAUCA',
                '19585000'  => 'COCONUCO-CAUCA',
                '19585000'  => 'COCONUCO-CAUCA',
                '19760000'  => 'PAISPAMBA-CAUCA',
                '19760000'  => 'PAISPAMBA-CAUCA',
                '19548001'  => 'TUNIA-CAUCA',
                '19110012'  => 'TIMBA-CAUCA',
                '19517000'  => 'BELALCÁZAR-CAUCA',
                '19517000'  => 'BELALCÁZAR-CAUCA',
                '19693004'  => 'SANTIAGO-CAUCA',
                '20060000'  => 'BOSCONIA-CESAR',
                '20770000'  => 'SAN MARTÍN-CESAR',
                '20228002'  => 'SAN ROQUE-CESAR',
                '20011000'  => 'AGUACHICA-CESAR',
                '20013000'  => 'AGUSTÍN CODAZZI-CESAR',
                '20032000'  => 'ASTREA-CESAR',
                '20045000'  => 'BECERRIL-CESAR',
                '20175000'  => 'CHIMICHAGUA-CESAR',
                '20178000'  => 'CHIRIGUANÁ-CESAR',
                '20228000'  => 'CURUMANÍ-CESAR',
                '20238000'  => 'EL COPEY-CESAR',
                '20250000'  => 'EL PASO-CESAR',
                '20295000'  => 'GAMARRA-CESAR',
                '20310000'  => 'GONZÁLEZ-CESAR',
                '20383000'  => 'LA GLORIA-CESAR',
                '20400000'  => 'LA JAGUA DE IBIRICO-CESAR',
                '20621000'  => 'LA PAZ-CESAR',
                '20443000'  => 'MANAURE-CESAR',
                '20517000'  => 'PAILITAS-CESAR',
                '20550000'  => 'PELAYA-CESAR',
                '20570000'  => 'PUEBLO BELLO-CESAR',
                '20614000'  => 'RÍO DE ORO-CESAR',
                '20710000'  => 'SAN ALBERTO-CESAR',
                '20750000'  => 'SAN DIEGO-CESAR',
                '20787000'  => 'TAMALAMEQUE-CESAR',
                '20001000'  => 'VALLEDUPAR-CESAR',
                '20013002'  => 'CASACAZA-CESAR',
                '20250002'  => 'LA LOMA-CESAR',
                '20383010'  => 'LA MATA-CESAR',
                '20178016'  => 'LA SIERRA-CESAR',
                '20175009'  => 'LAS VEGAS-CESAR',
                '20011025'  => 'EL JUNCAL-CESAR',
                '27006000'  => 'ACANDÍ-CHOCÓ',
                '27073000'  => 'BAGADÓ-CHOCÓ',
                '27205000'  => 'CONDOTO-CHOCÓ',
                '27245000'  => 'EL CARMEN DE ATRATO-CHOCÓ',
                '27361000'  => 'ISTMINA-CHOCÓ',
                '27372000'  => 'JURADÓ-CHOCÓ',
                '27413000'  => 'LLORÓ-CHOCÓ',
                '27491000'  => 'NÓVITA-CHOCÓ',
                '27495000'  => 'NUQUÍ-CHOCÓ',
                '27001000'  => 'QUIBDÓ-CHOCÓ',
                '27615000'  => 'RIOSUCIO-CHOCÓ',
                '27660000'  => 'SAN JOSÉ DEL PALMAR-CHOCÓ',
                '27745000'  => 'SIPÍ-CHOCÓ',
                '27787000'  => 'TADÓ-CHOCÓ',
                '27800000'  => 'UNGUÍA-CHOCÓ',
                '27160000'  => 'CÉRTEGUI-CHOCÓ',
                '27099000'  => 'BELLAVISTA-CHOCÓ',
                '27099000'  => 'BELLAVISTA-CHOCÓ',
                '27150000'  => 'CURBARADO-CHOCÓ',
                '27150000'  => 'CURBARADO-CHOCÓ',
                '27135000'  => 'MANAGRU-CHOCÓ',
                '27135000'  => 'MANAGRU-CHOCÓ',
                '27600000'  => 'PAIMADO-CHOCÓ',
                '27600000'  => 'PAIMADO-CHOCÓ',
                '27077000'  => 'PIZARRO-CHOCÓ',
                '27077000'  => 'PIZARRO-CHOCÓ',
                '27430000'  => 'PUERTO MELUK-CHOCÓ',
                '27580000'  => 'SANTA RITA-CHOCÓ',
                '27580000'  => 'SANTA RITA-CHOCÓ',
                '27450000'  => 'ANDAGOYA-CHOCÓ',
                '27615023'  => 'BELÉN DE BAJIRÁ-CHOCÓ',
                '27050000'  => 'YUTO-CHOCÓ',
                '23068000'  => 'AYAPEL-CÓRDOBA',
                '23079000'  => 'BUENAVISTA-CÓRDOBA',
                '23090000'  => 'CANALETE-CÓRDOBA',
                '23162000'  => 'CERETÉ-CÓRDOBA',
                '23168000'  => 'CHIMÁ-CÓRDOBA',
                '23182000'  => 'CHINÚ-CÓRDOBA',
                '23189000'  => 'CIÉNAGA DE ORO-CÓRDOBA',
                '23300000'  => 'COTORRA-CÓRDOBA',
                '23350000'  => 'LA APARTADA-CÓRDOBA',
                '23417000'  => 'LORICA-CÓRDOBA',
                '23419000'  => 'LOS CÓRDOBAS-CÓRDOBA',
                '23464000'  => 'MOMIL-CÓRDOBA',
                '23466000'  => 'MONTELÍBANO-CÓRDOBA',
                '23001000'  => 'MONTERÍA-CÓRDOBA',
                '23500000'  => 'MOÑITOS-CÓRDOBA',
                '23555000'  => 'PLANETA RICA-CÓRDOBA',
                '23570000'  => 'PUEBLO NUEVO-CÓRDOBA',
                '23574000'  => 'PUERTO ESCONDIDO-CÓRDOBA',
                '23580000'  => 'PUERTO LIBERTADOR-CÓRDOBA',
                '23586000'  => 'PURÍSIMA-CÓRDOBA',
                '23660000'  => 'SAHAGÚN-CÓRDOBA',
                '23670000'  => 'SAN ANDRÉS SOTAVENTO-CÓRDOBA',
                '23672000'  => 'SAN ANTERO-CÓRDOBA',
                '23675000'  => 'SAN BERNARDO DEL VIENTO-CÓRDOBA',
                '23678000'  => 'SAN CARLOS-CÓRDOBA',
                '23682000'  => 'SAN JOSÉ DE URÉ-CÓRDOBA',
                '23686000'  => 'SAN PELAYO-CÓRDOBA',
                '23807000'  => 'TIERRALTA-CÓRDOBA',
                '23815000'  => 'TUCHÍN-CÓRDOBA',
                '23855000'  => 'VALENCIA-CÓRDOBA',
                '23686002'  => 'CARRILLO-CÓRDOBA',
                '23686002'  => 'CARRILLO-CÓRDOBA',
                '23466023'  => 'CÓRDOBA-CÓRDOBA',
                '23672001'  => 'EL PORVENIR (C)-CÓRDOBA',
                '23672001'  => 'EL PORVENIR (C)-CÓRDOBA',
                '23001011'  => 'LOS GARZONES-CÓRDOBA',
                '23001011'  => 'LOS GARZONES-CÓRDOBA',
                '25335000'  => 'GUAYABETAL-CUNDINAMARCA',
                '25438000'  => 'MEDINA-CUNDINAMARCA',
                '25530000'  => 'PARATEBUENO-CUNDINAMARCA',
                '25126000'  => 'CAJICÁ-CUNDINAMARCA',
                '25175000'  => 'CHÍA-CUNDINAMARCA',
                '25214000'  => 'COTA-CUNDINAMARCA',
                '25286000'  => 'FUNZA-CUNDINAMARCA',
                '25312000'  => 'GRANADA-CUNDINAMARCA',
                '25473000'  => 'MOSQUERA-CUNDINAMARCA',
                '25491000'  => 'NOCAIMA-CUNDINAMARCA',
                '25513000'  => 'PACHO-CUNDINAMARCA',
                '25754000'  => 'SOACHA-CUNDINAMARCA',
                '25758000'  => 'SOPÓ-CUNDINAMARCA',
                '25845000'  => 'UNE-CUNDINAMARCA',
                '25506000'  => 'VENECIA-CUNDINAMARCA',
                '25875000'  => 'VILLETA-CUNDINAMARCA',
                '25899000'  => 'ZIPAQUIRÁ-CUNDINAMARCA',
                '25486000'  => 'NEMOCÓN-CUNDINAMARCA',
                '25001000'  => 'AGUA DE DIOS-CUNDINAMARCA',
                '25019000'  => 'ALBÁN-CUNDINAMARCA',
                '25019000'  => 'ALBÁN-CUNDINAMARCA',
                '25035000'  => 'ANAPOIMA-CUNDINAMARCA',
                '25040000'  => 'ANOLAIMA-CUNDINAMARCA',
                '25599000'  => 'APULO-CUNDINAMARCA',
                '25053000'  => 'ARBELÁEZ-CUNDINAMARCA',
                '25086000'  => 'BELTRÁN-CUNDINAMARCA',
                '25095000'  => 'BITUIMA-CUNDINAMARCA',
                '25099000'  => 'BOJACÁ-CUNDINAMARCA',
                '25120000'  => 'CABRERA-CUNDINAMARCA',
                '25123000'  => 'CACHIPAY-CUNDINAMARCA',
                '25148000'  => 'CAPARRAPÍ-CUNDINAMARCA',
                '25151000'  => 'CAQUEZA-CUNDINAMARCA',
                '25154000'  => 'CARMEN DE CARUPA-CUNDINAMARCA',
                '25168000'  => 'CHAGUANÍ-CUNDINAMARCA',
                '25178000'  => 'CHIPAQUE-CUNDINAMARCA',
                '25181000'  => 'CHOACHÍ-CUNDINAMARCA',
                '25183000'  => 'CHOCONTÁ-CUNDINAMARCA',
                '25200000'  => 'COGUA-CUNDINAMARCA',
                '25224000'  => 'CUCUNUBÁ-CUNDINAMARCA',
                '25245000'  => 'EL COLEGIO-CUNDINAMARCA',
                '25258000'  => 'EL PEÑÓN-CUNDINAMARCA',
                '25260000'  => 'EL ROSAL-CUNDINAMARCA',
                '25269000'  => 'FACATATIVÁ-CUNDINAMARCA',
                '25279000'  => 'FOMEQUE-CUNDINAMARCA',
                '25281000'  => 'FOSCA-CUNDINAMARCA',
                '25288000'  => 'FÚQUENE-CUNDINAMARCA',
                '25290000'  => 'FUSAGASUGÁ-CUNDINAMARCA',
                '25293000'  => 'GACHALA-CUNDINAMARCA',
                '25295000'  => 'GACHANCIPÁ-CUNDINAMARCA',
                '25297000'  => 'GACHETÁ-CUNDINAMARCA',
                '25299000'  => 'GAMA-CUNDINAMARCA',
                '25307000'  => 'GIRARDOT-CUNDINAMARCA',
                '25317000'  => 'GUACHETÁ-CUNDINAMARCA',
                '25320000'  => 'GUADUAS-CUNDINAMARCA',
                '25322000'  => 'GUASCA-CUNDINAMARCA',
                '25324000'  => 'GUATAQUÍ-CUNDINAMARCA',
                '25326000'  => 'GUATAVITA-CUNDINAMARCA',
                '25328000'  => 'GUAYABAL DE SIQUIMA-CUNDINAMARCA',
                '25339000'  => 'GUTIÉRREZ-CUNDINAMARCA',
                '25368000'  => 'JERUSALÉN-CUNDINAMARCA',
                '25372000'  => 'JUNÍN-CUNDINAMARCA',
                '25377000'  => 'LA CALERA-CUNDINAMARCA',
                '25386000'  => 'LA MESA-CUNDINAMARCA',
                '25394000'  => 'LA PALMA-CUNDINAMARCA',
                '25398000'  => 'LA PEÑA-CUNDINAMARCA',
                '25398000'  => 'LA PEÑA-CUNDINAMARCA',
                '25402000'  => 'LA VEGA-CUNDINAMARCA',
                '25407000'  => 'LENGUAZAQUE-CUNDINAMARCA',
                '25426000'  => 'MACHETA-CUNDINAMARCA',
                '25430000'  => 'MADRID-CUNDINAMARCA',
                '25436000'  => 'MANTA-CUNDINAMARCA',
                '25483000'  => 'NARIÑO-CUNDINAMARCA',
                '25488000'  => 'NILO-CUNDINAMARCA',
                '25489000'  => 'NIMAIMA-CUNDINAMARCA',
                '25518000'  => 'PAIME-CUNDINAMARCA',
                '25524000'  => 'PANDI-CUNDINAMARCA',
                '25535000'  => 'PASCA-CUNDINAMARCA',
                '25572000'  => 'PUERTO SALGAR-CUNDINAMARCA',
                '25580000'  => 'PULÍ-CUNDINAMARCA',
                '25592000'  => 'QUEBRADANEGRA-CUNDINAMARCA',
                '25594000'  => 'QUETAME-CUNDINAMARCA',
                '25596000'  => 'QUIPILE-CUNDINAMARCA',
                '25612000'  => 'RICAURTE-CUNDINAMARCA',
                '25645000'  => 'SAN ANTONIO DEL TEQUENDAMA-CUNDINAMARCA',
                '25649000'  => 'SAN BERNARDO-CUNDINAMARCA',
                '25377015'  => 'SAN CAYETANO-CUNDINAMARCA',
                '25372008'  => 'SAN FRANCISCO-CUNDINAMARCA',
                '25662000'  => 'SAN JUAN DE RÍO SECO-CUNDINAMARCA',
                '25718000'  => 'SASAIMA-CUNDINAMARCA',
                '25736000'  => 'SESQUILÉ-CUNDINAMARCA',
                '25740000'  => 'SIBATÉ-CUNDINAMARCA',
                '25743000'  => 'SILVANIA-CUNDINAMARCA',
                '25745000'  => 'SIMIJACA-CUNDINAMARCA',
                '25769000'  => 'SUBACHOQUE-CUNDINAMARCA',
                '25772000'  => 'SUESCA-CUNDINAMARCA',
                '25777000'  => 'SUPATÁ-CUNDINAMARCA',
                '25779000'  => 'SUSA-CUNDINAMARCA',
                '25781000'  => 'SUTATAUSA-CUNDINAMARCA',
                '25785000'  => 'TABIO-CUNDINAMARCA',
                '25793000'  => 'TAUSA-CUNDINAMARCA',
                '25797000'  => 'TENA-CUNDINAMARCA',
                '25799000'  => 'TENJO-CUNDINAMARCA',
                '25805000'  => 'TIBACUY-CUNDINAMARCA',
                '25807000'  => 'TIBIRITA-CUNDINAMARCA',
                '25815000'  => 'TOCAIMA-CUNDINAMARCA',
                '25817000'  => 'TOCANCIPÁ-CUNDINAMARCA',
                '25823000'  => 'TOPAIPÍ-CUNDINAMARCA',
                '25839000'  => 'UBALÁ-CUNDINAMARCA',
                '25841000'  => 'UBAQUE-CUNDINAMARCA',
                '25851000'  => 'ÚTICA-CUNDINAMARCA',
                '25862000'  => 'VERGARA-CUNDINAMARCA',
                '25867000'  => 'VIANÍ-CUNDINAMARCA',
                '25843000'  => 'VILLA DE SAN DIEGO DE UBATE-CUNDINAMARCA',
                '25871000'  => 'VILLAGÓMEZ-CUNDINAMARCA',
                '25873000'  => 'VILLAPINZÓN-CUNDINAMARCA',
                '25878000'  => 'VIOTÁ-CUNDINAMARCA',
                '25885000'  => 'YACOPÍ-CUNDINAMARCA',
                '25898000'  => 'ZIPACÓN-CUNDINAMARCA',
                '25290016'  => 'CHINAUTA-CUNDINAMARCA',
                '25288001'  => 'CAPELLANIA-CUNDINAMARCA',
                '25288001'  => 'CAPELLANIA-CUNDINAMARCA',
                '25245001'  => 'EL TRIUNFO-CUNDINAMARCA',
                '25040002'  => 'LA FLORIDA-CUNDINAMARCA',
                '25797001'  => 'LA GRAN VÍA-CUNDINAMARCA',
                '25797001'  => 'LA GRAN VÍA-CUNDINAMARCA',
                '25245002'  => 'LA VICTORIA-CUNDINAMARCA',
                '25335004'  => 'LIMONCITOS-CUNDINAMARCA',
                '25335004'  => 'LIMONCITOS-CUNDINAMARCA',
                '25488002'  => 'PUEBLO NUEVO-CUNDINAMARCA',
                '25430004'  => 'PUENTE DE PIEDRA-CUNDINAMARCA',
                '25430004'  => 'PUENTE DE PIEDRA-CUNDINAMARCA',
                '25594002'  => 'PUENTE QUETAME-CUNDINAMARCA',
                '25594002'  => 'PUENTE QUETAME-CUNDINAMARCA',
                '25320003'  => 'PUERTO BOGOTA-CUNDINAMARCA',
                '25320003'  => 'PUERTO BOGOTA-CUNDINAMARCA',
                '25386003'  => 'SAN JOAQUÍN-CUNDINAMARCA',
                '25645001'  => 'SANTANDERCITO-CUNDINAMARCA',
                '25645001'  => 'SANTANDERCITO-CUNDINAMARCA',
                '25817013'  => 'TIBITO-CUNDINAMARCA',
                '25817013'  => 'TIBITO-CUNDINAMARCA',
                '25592003'  => 'TOBIA-CUNDINAMARCA',
                '25592003'  => 'TOBIA-CUNDINAMARCA',
                '95200000'  => 'MIRAFLORES-GUAVIARE',
                '95025000'  => 'EL RETORNO-GUAVIARE',
                '95001000'  => 'SAN JOSÉ DEL GUAVIARE-GUAVIARE',
                '41676000'  => 'SANTA MARÍA-HUILA',
                '41001000'  => 'NEIVA-HUILA',
                '41006000'  => 'ACEVEDO-HUILA',
                '41013000'  => 'AGRADO-HUILA',
                '41016000'  => 'AIPE-HUILA',
                '41020000'  => 'ALGECIRAS-HUILA',
                '41026000'  => 'ALTAMIRA-HUILA',
                '41078000'  => 'BARAYA-HUILA',
                '41132000'  => 'CAMPOALEGRE-HUILA',
                '41206000'  => 'COLOMBIA-HUILA',
                '41244000'  => 'ELÍAS-HUILA',
                '41298000'  => 'GARZÓN-HUILA',
                '41306000'  => 'GIGANTE-HUILA',
                '41319000'  => 'GUADALUPE-HUILA',
                '41349000'  => 'HOBO-HUILA',
                '41357000'  => 'IQUIRA-HUILA',
                '41359000'  => 'ISNOS-HUILA',
                '41378000'  => 'LA ARGENTINA-HUILA',
                '41396000'  => 'LA PLATA-HUILA',
                '41483000'  => 'NÁTAGA-HUILA',
                '41503000'  => 'OPORAPA-HUILA',
                '41518000'  => 'PAICOL-HUILA',
                '41530000'  => 'PALESTINA-HUILA',
                '41548000'  => 'PITAL-HUILA',
                '41551000'  => 'PITALITO-HUILA',
                '41615000'  => 'RIVERA-HUILA',
                '41660000'  => 'SALADOBLANCO-HUILA',
                '41668000'  => 'SAN AGUSTÍN-HUILA',
                '41770000'  => 'SUAZA-HUILA',
                '41791000'  => 'TARQUI-HUILA',
                '41799000'  => 'TELLO-HUILA',
                '41801000'  => 'TERUEL-HUILA',
                '41797000'  => 'TESALIA-HUILA',
                '41807000'  => 'TIMANÁ-HUILA',
                '41872000'  => 'VILLAVIEJA-HUILA',
                '41885000'  => 'YAGUARÁ-HUILA',
                '41524000'  => 'PALERMO-HUILA',
                '41396001'  => 'BELEN (H)-HUILA',
                '41396001'  => 'BELEN (H)-HUILA',
                '41551001'  => 'BRUSELAS-HUILA',
                '41551001'  => 'BRUSELAS-HUILA',
                '41001001'  => 'CAGUAN-HUILA',
                '41001001'  => 'CAGUAN-HUILA',
                '41524006'  => 'EL JUNCAL-HUILA',
                '41524006'  => 'EL JUNCAL-HUILA',
                '41001003'  => 'FORTALECILLAS-HUILA',
                '41001003'  => 'FORTALECILLAS-HUILA',
                '41770002'  => 'GUAYABAL (HUL)-HUILA',
                '41770002'  => 'GUAYABAL (HUL)-HUILA',
                '41797001'  => 'PACARNI-HUILA',
                '41797001'  => 'PACARNI-HUILA',
                '41615001'  => 'ULLOA-HUILA',
                '41298004'  => 'ZULUAGA-HUILA',
                '41298004'  => 'ZULUAGA-HUILA',
                '44035000'  => 'ALBANIA-LA GUAJIRA',
                '44110000'  => 'EL MOLINO-LA GUAJIRA',
                '44874000'  => 'VILLANUEVA-LA GUAJIRA',
                '44078000'  => 'BARRANCAS-LA GUAJIRA',
                '44090000'  => 'DIBULA-LA GUAJIRA',
                '44098000'  => 'DISTRACCIÓN-LA GUAJIRA',
                '44279000'  => 'FONSECA-LA GUAJIRA',
                '44378000'  => 'HATONUEVO-LA GUAJIRA',
                '44420000'  => 'LA JAGUA DEL PILAR-LA GUAJIRA',
                '44430000'  => 'MAICAO-LA GUAJIRA',
                '44560000'  => 'MANAURE-LA GUAJIRA',
                '44001000'  => 'RIOHACHA-LA GUAJIRA',
                '44650000'  => 'SAN JUAN DEL CESAR-LA GUAJIRA',
                '44847000'  => 'URIBIA-LA GUAJIRA',
                '44855000'  => 'URUMITA-LA GUAJIRA',
                '44430005'  => 'LA PAZ-LA GUAJIRA',
                '44090003'  => 'MINGUEO-LA GUAJIRA',
                '44090003'  => 'MINGUEO-LA GUAJIRA',
                '44090004'  => 'PALOMINO-LA GUAJIRA',
                '44090004'  => 'PALOMINO-LA GUAJIRA',
                '44430007'  => 'PARAGUACHON-LA GUAJIRA',
                '44430007'  => 'PARAGUACHON-LA GUAJIRA',
                '47189000'  => 'CIÉNAGA-MAGDALENA',
                '47551000'  => 'PIVIJAY-MAGDALENA',
                '47692000'  => 'SAN SEBASTIÁN DE BUENAVISTA-MAGDALENA',
                '47707000'  => 'SANTA ANA-MAGDALENA',
                '47980003'  => 'LA GRAN VIA-MAGDALENA',
                '47980003'  => 'LA GRAN VIA-MAGDALENA',
                '47030000'  => 'ALGARROBO-MAGDALENA',
                '47053000'  => 'ARACATACA-MAGDALENA',
                '47161000'  => 'CERRO SAN ANTONIO-MAGDALENA',
                '47170000'  => 'CHIVOLO-MAGDALENA',
                '47205000'  => 'CONCORDIA-MAGDALENA',
                '47245000'  => 'EL BANCO-MAGDALENA',
                '47258000'  => 'EL PIÑON-MAGDALENA',
                '47268000'  => 'EL RETÉN-MAGDALENA',
                '47288000'  => 'FUNDACIÓN-MAGDALENA',
                '47318000'  => 'GUAMAL-MAGDALENA',
                '47541000'  => 'PEDRAZA-MAGDALENA',
                '47545000'  => 'PIJIÑO DEL CARMEN-MAGDALENA',
                '47555000'  => 'PLATO-MAGDALENA',
                '47570000'  => 'PUEBLO VIEJO-MAGDALENA',
                '47605000'  => 'REMOLINO-MAGDALENA',
                '47660000'  => 'SABANAS DE SAN ANGEL-MAGDALENA',
                '47675000'  => 'SALAMINA-MAGDALENA',
                '47703000'  => 'SAN ZENÓN-MAGDALENA',
                '47720000'  => 'SANTA BÁRBARA DE PINTO-MAGDALENA',
                '47001000'  => 'SANTA MARTA-MAGDALENA',
                '47745000'  => 'SITIONUEVO-MAGDALENA',
                '47798000'  => 'TENERIFE-MAGDALENA',
                '47001038'  => 'GAIRA-MAGDALENA',
                '47001010'  => 'TAGANGA-MAGDALENA',
                '47001011'  => 'BURITACA-MAGDALENA',
                '47001011'  => 'BURITACA-MAGDALENA',
                '47258003'  => 'CARRETO-MAGDALENA',
                '47258003'  => 'CARRETO-MAGDALENA',
                '47245018'  => 'GUACAMAYAL-MAGDALENA',
                '47001006'  => 'GUACHACA-MAGDALENA',
                '47001006'  => 'GUACHACA-MAGDALENA',
                '47745003'  => 'PALERMO-MAGDALENA',
                '47980000'  => 'PRADO - SEVILLA-MAGDALENA',
                '47980000'  => 'PRADO - SEVILLA-MAGDALENA',
                '47980000'  => 'PRADO - SEVILLA-MAGDALENA',
                '47960000'  => 'PUNTA DE PIEDRAS-MAGDALENA',
                '47960000'  => 'PUNTA DE PIEDRAS-MAGDALENA',
                '47960000'  => 'PUNTA DE PIEDRAS-MAGDALENA',
                '47980007'  => 'SANTA ROSALÍA-MAGDALENA',
                '50006000'  => 'ACACIAS-META',
                '50110000'  => 'BARRANCA DE UPÍA-META',
                '50150000'  => 'CASTILLA LA NUEVA-META',
                '50223000'  => 'CUBARRAL-META',
                '50251000'  => 'EL CASTILLO-META',
                '50270000'  => 'EL DORADO-META',
                '50287000'  => 'FUENTE DE ORO-META',
                '50313000'  => 'GRANADA-META',
                '50318000'  => 'GUAMAL-META',
                '50400000'  => 'LEJANÍAS-META',
                '50330000'  => 'MESETAS-META',
                '50450000'  => 'PUERTO CONCORDIA-META',
                '50568000'  => 'PUERTO GAITÁN-META',
                '50577000'  => 'PUERTO LLERAS-META',
                '50573000'  => 'PUERTO LÓPEZ-META',
                '50590000'  => 'PUERTO RICO-META',
                '50606000'  => 'RESTREPO-META',
                '50680000'  => 'SAN CARLOS DE GUAROA-META',
                '50683000'  => 'SAN JUAN DE ARAMA-META',
                '50689000'  => 'SAN MARTÍN-META',
                '50001000'  => 'VILLAVICENCIO-META',
                '50711000'  => 'VISTA HERMOSA-META',
                '50573003'  => 'PACHAQUIARO-META',
                '50001015'  => 'ALTO POMPEYA-META',
                '50001015'  => 'ALTO POMPEYA-META',
                '50680003'  => 'LA PALMERA-META',
                '50680003'  => 'LA PALMERA-META',
                '50226000'  => 'CUMARAL-META',
                '50245000'  => 'EL CALVARIO-META',
                '50686000'  => 'SAN JUANITO-META',
                '52083000'  => 'BELÉN-NARIÑO',
                '52227000'  => 'CUMBAL-NARIÑO',
                '52317000'  => 'GUACHUCAL-NARIÑO',
                '52320000'  => 'GUAITARILLA-NARIÑO',
                '52356000'  => 'IPIALES-NARIÑO',
                '52399000'  => 'LA UNIÓN-NARIÑO',
                '52001000'  => 'PASTO-NARIÑO',
                '52585000'  => 'PUPIALES-NARIÑO',
                '52678000'  => 'SAMANIEGO-NARIÑO',
                '52693000'  => 'SAN PABLO-NARIÑO',
                '52683000'  => 'SANDONÁ-NARIÑO',
                '52838000'  => 'TÚQUERRES-NARIÑO',
                '52203000'  => 'GÉNOVA-NARIÑO',
                '52203000'  => 'GÉNOVA-NARIÑO',
                '52473000'  => 'MOSQUERA-NARIÑO',
                '52683004'  => 'SANTA BÁRBARA-NARIÑO',
                '52838001'  => 'ALBÁN-NARIÑO',
                '52022000'  => 'ALDANA-NARIÑO',
                '52036000'  => 'ANCUYÁ-NARIÑO',
                '52051000'  => 'ARBOLEDA-NARIÑO',
                '52079000'  => 'BARBACOAS-NARIÑO',
                '52110000'  => 'BUESACO-NARIÑO',
                '52240000'  => 'CHACHAGÜÍ-NARIÑO',
                '52207000'  => 'CONSACA-NARIÑO',
                '52210000'  => 'CONTADERO-NARIÑO',
                '52233000'  => 'CUMBITARA-NARIÑO',
                '52250000'  => 'EL CHARCO-NARIÑO',
                '52256000'  => 'EL ROSARIO-NARIÑO',
                '52258000'  => 'EL TABLÓN DE GÓMEZ-NARIÑO',
                '52260000'  => 'EL TAMBO-NARIÑO',
                '52287000'  => 'FUNES-NARIÑO',
                '52323000'  => 'GUALMATÁN-NARIÑO',
                '52352000'  => 'ILES-NARIÑO',
                '52378000'  => 'LA CRUZ-NARIÑO',
                '52381000'  => 'LA FLORIDA-NARIÑO',
                '52385000'  => 'LA LLANADA-NARIÑO',
                '52390000'  => 'LA TOLA-NARIÑO',
                '52405000'  => 'LEIVA-NARIÑO',
                '52411000'  => 'LINARES-NARIÑO',
                '52480000'  => 'NARIÑO-NARIÑO',
                '52506000'  => 'OSPINA-NARIÑO',
                '52540000'  => 'POLICARPA-NARIÑO',
                '52560000'  => 'POTOSÍ-NARIÑO',
                '52565000'  => 'PROVIDENCIA-NARIÑO',
                '52573000'  => 'PUERRES-NARIÑO',
                '52685000'  => 'SAN BERNARDO-NARIÑO',
                '52687000'  => 'SAN LORENZO-NARIÑO',
                '52694000'  => 'SAN PEDRO DE CARTAGO-NARIÑO',
                '52540006'  => 'SANTACRUZ-NARIÑO',
                '52720000'  => 'SAPUYES-NARIÑO',
                '52786000'  => 'TAMINANGO-NARIÑO',
                '52788000'  => 'TANGUA-NARIÑO',
                '52885000'  => 'YACUANQUER-NARIÑO',
                '52254000'  => 'EL PEÑOL-NARIÑO',
                '52001001'  => 'CATAMBUCO-NARIÑO',
                '52001001'  => 'CATAMBUCO-NARIÑO',
                '52001003'  => 'EL ENCANTO-NARIÑO',
                '52612000'  => 'RICAURTE (N)-NARIÑO',
                '52612000'  => 'RICAURTE (N)-NARIÑO',
                '52612000'  => 'RICAURTE (N)-NARIÑO',
                '52001024'  => 'SAN JOSÉ-NARIÑO',
                '54001000'  => 'CÚCUTA-NORTE DE SANTANDER',
                '54003000'  => 'ABREGO-NORTE DE SANTANDER',
                '54051000'  => 'ARBOLEDAS-NORTE DE SANTANDER',
                '54099000'  => 'BOCHALEMA-NORTE DE SANTANDER',
                '54109000'  => 'BUCARASICA-NORTE DE SANTANDER',
                '54128000'  => 'CACHIRÁ-NORTE DE SANTANDER',
                '54125000'  => 'CÁCOTA-NORTE DE SANTANDER',
                '54172000'  => 'CHINÁCOTA-NORTE DE SANTANDER',
                '54174000'  => 'CHITAGÁ-NORTE DE SANTANDER',
                '54206000'  => 'CONVENCIÓN-NORTE DE SANTANDER',
                '54223000'  => 'CUCUTILLA-NORTE DE SANTANDER',
                '54239000'  => 'DURANIA-NORTE DE SANTANDER',
                '54245000'  => 'EL CARMEN-NORTE DE SANTANDER',
                '54250000'  => 'EL TARRA-NORTE DE SANTANDER',
                '54261000'  => 'EL ZULIA-NORTE DE SANTANDER',
                '54313000'  => 'GRAMALOTE-NORTE DE SANTANDER',
                '54344000'  => 'HACARÍ-NORTE DE SANTANDER',
                '54347000'  => 'HERRÁN-NORTE DE SANTANDER',
                '54385000'  => 'LA ESPERANZA-NORTE DE SANTANDER',
                '54398000'  => 'LA PLAYA-NORTE DE SANTANDER',
                '54377000'  => 'LABATECA-NORTE DE SANTANDER',
                '54405000'  => 'LOS PATIOS-NORTE DE SANTANDER',
                '54418000'  => 'LOURDES-NORTE DE SANTANDER',
                '54480000'  => 'MUTISCUA-NORTE DE SANTANDER',
                '54498000'  => 'OCAÑA-NORTE DE SANTANDER',
                '54518000'  => 'PAMPLONA-NORTE DE SANTANDER',
                '54520000'  => 'PAMPLONITA-NORTE DE SANTANDER',
                '54553000'  => 'PUERTO SANTANDER-NORTE DE SANTANDER',
                '54599000'  => 'RAGONVALIA-NORTE DE SANTANDER',
                '54660000'  => 'SALAZAR-NORTE DE SANTANDER',
                '54670000'  => 'SAN CALIXTO-NORTE DE SANTANDER',
                '54673000'  => 'SAN CAYETANO-NORTE DE SANTANDER',
                '54680000'  => 'SANTIAGO-NORTE DE SANTANDER',
                '54720000'  => 'SARDINATA-NORTE DE SANTANDER',
                '54743000'  => 'SILOS-NORTE DE SANTANDER',
                '54800000'  => 'TEORAMA-NORTE DE SANTANDER',
                '54810000'  => 'TIBÚ-NORTE DE SANTANDER',
                '54820000'  => 'TOLEDO-NORTE DE SANTANDER',
                '54871000'  => 'VILLA CARO-NORTE DE SANTANDER',
                '54874000'  => 'VILLA DEL ROSARIO-NORTE DE SANTANDER',
                '54498002'  => 'AGUAS CLARAS-NORTE DE SANTANDER',
                '54498002'  => 'AGUAS CLARAS-NORTE DE SANTANDER',
                '54810017'  => 'CAMPO DOS-NORTE DE SANTANDER',
                '54810017'  => 'CAMPO DOS-NORTE DE SANTANDER',
                '54099002'  => 'LA DONJUANA-NORTE DE SANTANDER',
                '54099002'  => 'LA DONJUANA-NORTE DE SANTANDER',
                '54001033'  => 'LA JARRA-NORTE DE SANTANDER',
                '54001033'  => 'LA JARRA-NORTE DE SANTANDER',
                '54128003'  => 'LA VEGA-NORTE DE SANTANDER',
                '54820008'  => 'SAN BERNARDO DE BATA-NORTE DE SANTANDER',
                '54820008'  => 'SAN BERNARDO DE BATA-NORTE DE SANTANDER',
                '86568019'  => 'SANTANA-PUTUMAYO',
                '86219000'  => 'COLÓN-PUTUMAYO',
                '86001000'  => 'MOCOA-PUTUMAYO',
                '86320000'  => 'ORITO-PUTUMAYO',
                '86568000'  => 'PUERTO ASÍS-PUTUMAYO',
                '86569000'  => 'PUERTO CAICEDO-PUTUMAYO',
                '86571000'  => 'PUERTO GUZMÁN-PUTUMAYO',
                '86755000'  => 'SAN FRANCISCO-PUTUMAYO',
                '86760000'  => 'SANTIAGO-PUTUMAYO',
                '86749000'  => 'SIBUNDOY-PUTUMAYO',
                '86885000'  => 'VILLAGARZÓN-PUTUMAYO',
                '63001000'  => 'ARMENIA-QUINDÍO',
                '63130000'  => 'CALARCÁ-QUINDÍO',
                '63302000'  => 'GÉNOVA-QUINDÍO',
                '63190000'  => 'CIRCASIA-QUINDÍO',
                '63212000'  => 'CÓRDOBA-QUINDÍO',
                '63272000'  => 'FILANDIA-QUINDÍO',
                '63401000'  => 'LA TEBAIDA-QUINDÍO',
                '63470000'  => 'MONTENEGRO-QUINDÍO',
                '63548000'  => 'PIJAO-QUINDÍO',
                '63594000'  => 'QUIMBAYA-QUINDÍO',
                '63690000'  => 'SALENTO-QUINDÍO',
                '63130001'  => 'BARCELONA-QUINDÍO',
                '63130001'  => 'BARCELONA-QUINDÍO',
                '63001001'  => 'EL CAIMO-QUINDÍO',
                '63001001'  => 'EL CAIMO-QUINDÍO',
                '63470003'  => 'PUEBLO TAPADO-QUINDÍO',
                '63470003'  => 'PUEBLO TAPADO-QUINDÍO',
                '66001000'  => 'PEREIRA-RISARALDA',
                '66045000'  => 'APÍA-RISARALDA',
                '66075000'  => 'BALBOA-RISARALDA',
                '66088000'  => 'BELÉN DE UMBRÍA-RISARALDA',
                '66170000'  => 'DOSQUEBRADAS-RISARALDA',
                '66318000'  => 'GUÁTICA-RISARALDA',
                '66383000'  => 'LA CELIA-RISARALDA',
                '66400000'  => 'LA VIRGINIA-RISARALDA',
                '66440000'  => 'MARSELLA-RISARALDA',
                '66456000'  => 'MISTRATÓ-RISARALDA',
                '66594000'  => 'QUINCHÍA-RISARALDA',
                '66682000'  => 'SANTA ROSA DE CABAL-RISARALDA',
                '66687000'  => 'SANTUARIO-RISARALDA',
                '66572000'  => 'PUEBLO RICO-RISARALDA',
                '66001004'  => 'CAIMALITO-RISARALDA',
                '66001004'  => 'CAIMALITO-RISARALDA',
                '66001049'  => 'EL CRUCERO DE COMBIA-RISARALDA',
                '66001049'  => 'EL CRUCERO DE COMBIA-RISARALDA',
                '66594002'  => 'IRRA-RISARALDA',
                '66594002'  => 'IRRA-RISARALDA',
                '68020000'  => 'ALBANIA-SANTANDER',
                '68077000'  => 'BARBOSA-SANTANDER',
                '68572000'  => 'PUENTE NACIONAL-SANTANDER',
                '68861000'  => 'VÉLEZ-SANTANDER',
                '68079000'  => 'BARICHARA-SANTANDER',
                '68081000'  => 'BARRANCABERMEJA-SANTANDER',
                '68001000'  => 'BUCARAMANGA-SANTANDER',
                '68547000'  => 'PIEDECUESTA-SANTANDER',
                '68615000'  => 'RIONEGRO-SANTANDER',
                '68705000'  => 'SANTA BÁRBARA-SANTANDER',
                '68092000'  => 'BETULIA-SANTANDER',
                '68217000'  => 'COROMORO-SANTANDER',
                '68872000'  => 'VILLANUEVA-SANTANDER',
                '68013000'  => 'AGUADA-SANTANDER',
                '68051000'  => 'ARATOCA-SANTANDER',
                '68101000'  => 'BOLÍVAR-SANTANDER',
                '68121000'  => 'CABRERA-SANTANDER',
                '68132000'  => 'CALIFORNIA-SANTANDER',
                '68147000'  => 'CAPITANEJO-SANTANDER',
                '68152000'  => 'CARCASÍ-SANTANDER',
                '68160000'  => 'CEPITÁ-SANTANDER',
                '68162000'  => 'CERRITO-SANTANDER',
                '68167000'  => 'CHARALÁ-SANTANDER',
                '68169000'  => 'CHARTA-SANTANDER',
                '68176000'  => 'CHIMÁ-SANTANDER',
                '68179000'  => 'CHIPATÁ-SANTANDER',
                '68190000'  => 'CIMITARRA-SANTANDER',
                '68207000'  => 'CONCEPCIÓN-SANTANDER',
                '68209000'  => 'CONFINES-SANTANDER',
                '68211000'  => 'CONTRATACIÓN-SANTANDER',
                '68229000'  => 'CURITÍ-SANTANDER',
                '68235000'  => 'EL CARMEN DE CHUCURÍ-SANTANDER',
                '68245000'  => 'EL GUACAMAYO-SANTANDER',
                '68250000'  => 'EL PEÑÓN-SANTANDER',
                '68255000'  => 'EL PLAYÓN-SANTANDER',
                '68264000'  => 'ENCINO-SANTANDER',
                '68266000'  => 'ENCISO-SANTANDER',
                '68271000'  => 'FLORIÁN-SANTANDER',
                '68276000'  => 'FLORIDABLANCA-SANTANDER',
                '68296000'  => 'GALÁN-SANTANDER',
                '68298000'  => 'GAMBITA-SANTANDER',
                '68307000'  => 'GIRÓN-SANTANDER',
                '68318000'  => 'GUACA-SANTANDER',
                '68320000'  => 'GUADALUPE-SANTANDER',
                '68322000'  => 'GUAPOTÁ-SANTANDER',
                '68324000'  => 'GUAVATÁ-SANTANDER',
                '68344000'  => 'HATO-SANTANDER',
                '68368000'  => 'JESÚS MARÍA-SANTANDER',
                '68370000'  => 'JORDÁN-SANTANDER',
                '68377000'  => 'LA BELLEZA-SANTANDER',
                '68397000'  => 'LA PAZ-SANTANDER',
                '68397000'  => 'LA PAZ-SANTANDER',
                '68385000'  => 'LANDÁZURI-SANTANDER',
                '68406000'  => 'LEBRÍJA-SANTANDER',
                '68418000'  => 'LOS SANTOS-SANTANDER',
                '68425000'  => 'MACARAVITA-SANTANDER',
                '68432000'  => 'MÁLAGA-SANTANDER',
                '68444000'  => 'MATANZA-SANTANDER',
                '68464000'  => 'MOGOTES-SANTANDER',
                '68468000'  => 'MOLAGAVITA-SANTANDER',
                '68498000'  => 'OCAMONTE-SANTANDER',
                '68500000'  => 'OIBA-SANTANDER',
                '68502000'  => 'ONZAGA-SANTANDER',
                '68522000'  => 'PALMAR-SANTANDER',
                '68524000'  => 'PALMAS DEL SOCORRO-SANTANDER',
                '68524000'  => 'PALMAS DEL SOCORRO-SANTANDER',
                '68533000'  => 'PÁRAMO-SANTANDER',
                '68549000'  => 'PINCHOTE-SANTANDER',
                '68573000'  => 'PUERTO PARRA-SANTANDER',
                '68575000'  => 'PUERTO WILCHES-SANTANDER',
                '68655000'  => 'SABANA DE TORRES-SANTANDER',
                '68669000'  => 'SAN ANDRÉS-SANTANDER',
                '68673000'  => 'SAN BENITO-SANTANDER',
                '68679000'  => 'SAN GIL-SANTANDER',
                '68682000'  => 'SAN JOAQUÍN-SANTANDER',
                '68684000'  => 'SAN JOSÉ DE MIRANDA-SANTANDER',
                '68686000'  => 'SAN MIGUEL-SANTANDER',
                '68689000'  => 'SAN VICENTE DE CHUCURÍ-SANTANDER',
                '68720000'  => 'SANTA HELENA DEL OPÓN-SANTANDER',
                '68745000'  => 'SIMACOTA-SANTANDER',
                '68755000'  => 'SOCORRO-SANTANDER',
                '68770000'  => 'SUAITA-SANTANDER',
                '68773000'  => 'SUCRE-SANTANDER',
                '68780000'  => 'SURATÁ-SANTANDER',
                '68820000'  => 'TONA-SANTANDER',
                '68820000'  => 'TONA-SANTANDER',
                '68855000'  => 'VALLE DE SAN JOSÉ-SANTANDER',
                '68867000'  => 'VETAS-SANTANDER',
                '68895000'  => 'ZAPATOCA-SANTANDER',
                '68081001'  => 'EL CENTRO-SANTANDER',
                '68307007'  => 'ACAPULCO-SANTANDER',
                '68307007'  => 'ACAPULCO-SANTANDER',
                '68820001'  => 'BERLIN-SANTANDER',
                '68081002'  => 'EL LLANITO-SANTANDER',
                '68081002'  => 'EL LLANITO-SANTANDER',
                '68081009'  => 'LOS LAURELES-SANTANDER',
                '68081009'  => 'LOS LAURELES-SANTANDER',
                '68770001'  => 'OLIVAL-SANTANDER',
                '68770001'  => 'OLIVAL-SANTANDER',
                '54874008'  => 'PALO GORDO-SANTANDER',
                '54874008'  => 'PALO GORDO-SANTANDER',
                '68575015'  => 'PUENTE SOGAMOSO-SANTANDER',
                '68575015'  => 'PUENTE SOGAMOSO-SANTANDER',
                '68190002'  => 'PUERTO ARAUJO-SANTANDER',
                '68190002'  => 'PUERTO ARAUJO-SANTANDER',
                '68615031'  => 'SAN RAFAEL-SANTANDER',
                '68092008'  => 'TIENDA NUEVA-SANTANDER',
                '68092008'  => 'TIENDA NUEVA-SANTANDER',
                '68770003'  => 'VADO REAL-SANTANDER',
                '68770003'  => 'VADO REAL-SANTANDER',
                '68689012'  => 'YARIMA-SANTANDER',
                '68689012'  => 'YARIMA-SANTANDER',
                '70717000'  => 'SAN PEDRO-SUCRE',
                '70001000'  => 'SINCELEJO-SUCRE',
                '70110000'  => 'BUENA VISTA-SUCRE',
                '70124000'  => 'CAIMITO-SUCRE',
                '70230000'  => 'CHALÁN-SUCRE',
                '70215000'  => 'COROZAL-SUCRE',
                '70221000'  => 'COVEÑAS-SUCRE',
                '70233000'  => 'EL ROBLE-SUCRE',
                '70235000'  => 'GALERAS-SUCRE',
                '70265000'  => 'GUARANDA-SUCRE',
                '70400000'  => 'LA UNIÓN-SUCRE',
                '70418000'  => 'LOS PALMITOS-SUCRE',
                '70473000'  => 'MORROA-SUCRE',
                '70508000'  => 'OVEJAS-SUCRE',
                '70523000'  => 'PALMITO-SUCRE',
                '70670000'  => 'SAMPUÉS-SUCRE',
                '70678000'  => 'SAN BENITO ABAD-SUCRE',
                '70702000'  => 'SAN JUAN DE BETULIA-SUCRE',
                '70708000'  => 'SAN MARCOS-SUCRE',
                '70713000'  => 'SAN ONOFRE-SUCRE',
                '70771000'  => 'SUCRE-SUCRE',
                '70823000'  => 'TOLÚ VIEJO-SUCRE',
                '13430032'  => 'TOLÚ-BOLÍVAR',
                '70823018'  => 'ARMERO-SUCRE',
                '73001000'  => 'IBAGUÉ-TOLIMA',
                '73268000'  => 'ESPINAL-TOLIMA',
                '73024000'  => 'ALPUJARRA-TOLIMA',
                '73026000'  => 'ALVARADO-TOLIMA',
                '73030000'  => 'AMBALEMA-TOLIMA',
                '73055000'  => 'ARMERO-TOLIMA',
                '73067000'  => 'ATACO-TOLIMA',
                '73124000'  => 'CAJAMARCA-TOLIMA',
                '73148000'  => 'CARMEN DE APICALA-TOLIMA',
                '73168000'  => 'CHAPARRAL-TOLIMA',
                '73217000'  => 'COYAIMA-TOLIMA',
                '73226000'  => 'CUNDAY-TOLIMA',
                '73236000'  => 'DOLORES-TOLIMA',
                '73270000'  => 'FALAN-TOLIMA',
                '73275000'  => 'FLANDES-TOLIMA',
                '73283000'  => 'FRESNO-TOLIMA',
                '73319000'  => 'GUAMO-TOLIMA',
                '73347000'  => 'HERVEO-TOLIMA',
                '73349000'  => 'HONDA-TOLIMA',
                '73352000'  => 'ICONONZO-TOLIMA',
                '73408000'  => 'LÉRIDA-TOLIMA',
                '73411000'  => 'LÍBANO-TOLIMA',
                '73443000'  => 'MARIQUITA-TOLIMA',
                '73449000'  => 'MELGAR-TOLIMA',
                '73461000'  => 'MURILLO-TOLIMA',
                '73483000'  => 'NATAGAIMA-TOLIMA',
                '73504000'  => 'ORTEGA-TOLIMA',
                '73504000'  => 'ORTEGA-TOLIMA',
                '73520000'  => 'PALOCABILDO-TOLIMA',
                '73547000'  => 'PIEDRAS-TOLIMA',
                '73555000'  => 'PLANADAS-TOLIMA',
                '73563000'  => 'PRADO-TOLIMA',
                '73585000'  => 'PURIFICACIÓN-TOLIMA',
                '73616000'  => 'RIO BLANCO-TOLIMA',
                '73622000'  => 'RONCESVALLES-TOLIMA',
                '73624000'  => 'ROVIRA-TOLIMA',
                '73671000'  => 'SALDAÑA-TOLIMA',
                '73675000'  => 'SAN ANTONIO-TOLIMA',
                '73678000'  => 'SAN LUIS-TOLIMA',
                '73686000'  => 'SANTA ISABEL-TOLIMA',
                '73770000'  => 'SUÁREZ-TOLIMA',
                '73854000'  => 'VALLE DE SAN JUAN-TOLIMA',
                '73861000'  => 'VENADILLO-TOLIMA',
                '73870000'  => 'VILLAHERMOSA-TOLIMA',
                '73873000'  => 'VILLARRICA-TOLIMA',
                '73268001'  => 'CHICORAL-TOLIMA',
                '73268001'  => 'CHICORAL-TOLIMA',
                '73555002'  => 'GAITANIA-TOLIMA',
                '73001032'  => 'GUALANDAY-TOLIMA',
                '73616001'  => 'HERRERA-TOLIMA',
                '73067007'  => 'SANTIAGO PEREZ-TOLIMA',
                '73001001'  => 'BUENOS AIRES-TOLIMA',
                '73504008'  => 'OLAYA HERRERA-TOLIMA',
                '73030004'  => 'PAJONALES-TOLIMA',
                '73030004'  => 'PAJONALES-TOLIMA',
                '25488900'  => 'TOLEMAIDA-MELGAR-TOLIMA',
                '25488900'  => 'TOLEMAIDA-MELGAR-TOLIMA',
                '76020000'  => 'ALCALÁ-VALLE DEL CAUCA',
                '76001000'  => 'CALI-VALLE DEL CAUCA',
                '76126000'  => 'CALIMA-VALLE DEL CAUCA',
                '76233000'  => 'DAGUA-VALLE DEL CAUCA',
                '76248000'  => 'EL CERRITO-VALLE DEL CAUCA',
                '76250000'  => 'EL DOVIO-VALLE DEL CAUCA',
                '76275000'  => 'FLORIDA-VALLE DEL CAUCA',
                '76306000'  => 'GINEBRA-VALLE DEL CAUCA',
                '76318000'  => 'GUACARÍ-VALLE DEL CAUCA',
                '76111000'  => 'BUGA-VALLE DEL CAUCA',
                '76364000'  => 'JAMUNDÍ-VALLE DEL CAUCA',
                '76400000'  => 'LA UNIÓN-VALLE DEL CAUCA',
                '76520000'  => 'PALMIRA-VALLE DEL CAUCA',
                '76563000'  => 'PRADERA-VALLE DEL CAUCA',
                '76606000'  => 'RESTREPO-VALLE DEL CAUCA',
                '76616000'  => 'RIOFRÍO-VALLE DEL CAUCA',
                '76670000'  => 'SAN PEDRO-VALLE DEL CAUCA',
                '76736000'  => 'SEVILLA-VALLE DEL CAUCA',
                '76828000'  => 'TRUJILLO-VALLE DEL CAUCA',
                '76834000'  => 'TULUÁ-VALLE DEL CAUCA',
                '76892000'  => 'YUMBO-VALLE DEL CAUCA',
                '76248009'  => 'SANTA ELENA-VALLE DEL CAUCA',
                '76377000'  => 'LA CUMBRE-VALLE DEL CAUCA',
                '76001001'  => 'EL SALADITO-VALLE DEL CAUCA',
                '76001001'  => 'EL SALADITO-VALLE DEL CAUCA',
                '76520026'  => 'ROZO-VALLE DEL CAUCA',
                '76520026'  => 'ROZO-VALLE DEL CAUCA',
                '76111002'  => 'EL PLACER (V)-VALLE DEL CAUCA',
                '76111002'  => 'EL PLACER (V)-VALLE DEL CAUCA',
                '76233017'  => 'LOBO GUERRERO-VALLE DEL CAUCA',
                '76275011'  => 'SAN ANTONIO DE LOS CABALLEROS-VALLE DEL CAUCA',
                '76275011'  => 'SAN ANTONIO DE LOS CABALLEROS-VALLE DEL CAUCA',
                '76036000'  => 'ANDALUCÍA-VALLE DEL CAUCA',
                '76041000'  => 'ANSERMANUEVO-VALLE DEL CAUCA',
                '76054000'  => 'ARGELIA-VALLE DEL CAUCA',
                '76100000'  => 'BOLÍVAR-VALLE DEL CAUCA',
                '76109000'  => 'BUENAVENTURA-VALLE DEL CAUCA',
                '76113000'  => 'BUGALAGRANDE-VALLE DEL CAUCA',
                '76122000'  => 'CAICEDONIA-VALLE DEL CAUCA',
                '76130000'  => 'CANDELARIA-VALLE DEL CAUCA',
                '76147000'  => 'CARTAGO-VALLE DEL CAUCA',
                '76243000'  => 'EL ÁGUILA-VALLE DEL CAUCA',
                '76246000'  => 'EL CAIRO-VALLE DEL CAUCA',
                '76403000'  => 'LA VICTORIA-VALLE DEL CAUCA',
                '76497000'  => 'OBANDO-VALLE DEL CAUCA',
                '76622000'  => 'ROLDANILLO-VALLE DEL CAUCA',
                '76823000'  => 'TORO-VALLE DEL CAUCA',
                '76845000'  => 'ULLOA-VALLE DEL CAUCA',
                '76863000'  => 'VERSALLES-VALLE DEL CAUCA',
                '76869000'  => 'VIJES-VALLE DEL CAUCA',
                '76890000'  => 'YOTOCO-VALLE DEL CAUCA',
                '76895000'  => 'ZARZAL-VALLE DEL CAUCA',
                '76520002'  => 'AMAIME-VALLE DEL CAUCA',
                '76520002'  => 'AMAIME-VALLE DEL CAUCA',
                '76001024'  => 'CASCAJAL I-VALLE DEL CAUCA',
                '76001024'  => 'CASCAJAL I-VALLE DEL CAUCA',
                '76130003'  => 'EL CABUYAL (V)-VALLE DEL CAUCA',
                '76130003'  => 'EL CABUYAL (V)-VALLE DEL CAUCA',
                '76130004'  => 'EL CARMELO-VALLE DEL CAUCA',
                '76130004'  => 'EL CARMELO-VALLE DEL CAUCA',
                '76233011'  => 'EL QUEREMAL-VALLE DEL CAUCA',
                '76233011'  => 'EL QUEREMAL-VALLE DEL CAUCA',
                '76318004'  => 'GUABITAS-VALLE DEL CAUCA',
                '76318004'  => 'GUABITAS-VALLE DEL CAUCA',
                '76895002'  => 'LA PAILA-VALLE DEL CAUCA',
                '76895002'  => 'LA PAILA-VALLE DEL CAUCA',
                '76130008'  => 'VILLA GORGONA-VALLE DEL CAUCA',
                '76130008'  => 'VILLA GORGONA-VALLE DEL CAUCA',
                '76109078'  => 'ZARAGOZA (V)-VALLE DEL CAUCA',
                '76109078'  => 'ZARAGOZA (V)-VALLE DEL CAUCA',
                '97666000'  => 'TARAIRA-VAUPÉS',
                '99624000'  => 'SANTA ROSALÍA-VICHADA',
                '05001004'  => 'SANTA ELENA-ANTIOQUIA',
                '08001001'  => 'JUAN MINA-ATLÁNTICO',
                '15464000'  => 'MONGUA-BOYACÁ',
                '15180000'  => 'CHISCAS-BOYACÁ',
                '15790000'  => 'TASCO-BOYACÁ',
                '15676000'  => 'SAN MIGUEL DE SEMA-BOYACÁ',
                '15183000'  => 'CHITA-BOYACÁ',
                '15494000'  => 'NUEVO COLÓN-BOYACÁ',
                '15518000'  => 'PAJARITO-BOYACÁ',
                '15522000'  => 'PANQUEBA-BOYACÁ',
                '15696000'  => 'SANTA SOFÍA-BOYACÁ',
                '15442000'  => 'MARIPÍ-BOYACÁ',
                '15861008'  => 'TIERRA NEGRA-BOYACÁ',
                '17272005'  => 'SAMPUÉS-CALDAS',
                '85325000'  => 'SAN LUIS DE GACENO-CASANARE',
                '85325000'  => 'SAN LUIS DE GACENO-CASANARE',
                '85225000'  => 'NUNCHÍA-CASANARE',
                '85230000'  => 'OROCUÉ-CASANARE',
                '85400000'  => 'TÁMARA-CASANARE',
                '19845000'  => 'VILLA RICA-CAUCA',
                '19212000'  => 'CORINTO-CAUCA',
                '25743005'  => 'SUBIA-CUNDINAMARCA',
                '27810000'  => 'UNIÓN PANAMERICANA-CHOCÓ',
                '27810000'  => 'UNIÓN PANAMERICANA-CHOCÓ',
                '23660004'  => 'COLOMBOY-CÓRDOBA',
                '50001019'  => 'APIAY-META',
                '73200001'  => 'GUALANDAY-TOLIMA',
                '68081010'  => 'LA FORTUNA-SANTANDER',
                '85001002'  => 'LA CHAPARRERA-CASANARE',
                '52835031'  => 'LLORENTE-NARIÑO',
                '50251001'  => 'MEDELLIN DEL ARIARI-META',
                '47058000'  => 'ARIGUANÍ-MAGDALENA',
                '47460000'  => 'NUEVA GRANADA-MAGDALENA',
                '50325000'  => 'MAPIRIPÁN-META',
                '50350000'  => 'LA MACARENA-META',
                '52835000'  => 'SAN ANDRÉS DE TUMACO-NARIÑO',
                '52215000'  => 'CÓRDOBA-NARIÑO',
                '52215000'  => 'CÓRDOBA-NARIÑO',
                '52215000'  => 'CÓRDOBA-NARIÑO',
                '52354000'  => 'IMUÉS-NARIÑO',
                '86573000'  => 'LEGUÍZAMO-PUTUMAYO',
                '86573000'  => 'LEGUÍZAMO-PUTUMAYO',
                '86573000'  => 'LEGUÍZAMO-PUTUMAYO',
                '63111000'  => 'BUENA VISTA-QUINDÍO',
                '68327000'  => 'GÜEPSA-SANTANDER',
                '70429000'  => 'MAJAGUAL-SUCRE',
                '70820000'  => 'SANTIAGO DE TOLÚ-SUCRE',
                '73200000'  => 'COELLO-TOLIMA',
                '73200000'  => 'COELLO-TOLIMA',
                '73043000'  => 'ANZOÁTEGUI-TOLIMA',
                '73152000'  => 'CASABIANCA-TOLIMA',
                '73152000'  => 'CASABIANCA-TOLIMA',
                '91430000'  => 'LA VICTORIA-AMAZONAS',
                '97777000'  => 'PAPUNAUA-VAUPÉS',
                '95015000'  => 'CALAMAR-GUAVIARE',
                '50124000'  => 'CABUYARO-META',
                '88001000'  => 'SAN ANDRES ISLA-ARCHIPIÉLAGO DE SAN ANDRÉS, PROVIDENCIA Y SANTA CATALINA',
            ),

            'input_class' => array(
                'wc-enhanced-select',
            )
        ), $fields['shipping']['shipping_city'] );

        $fields['shipping']['shipping_city'] = $city_args;
        $fields['billing']['billing_city'] = $city_args; // Also change for billing field

        wc_enqueue_js( "
        jQuery( ':input.wc-enhanced-select' ).filter( ':not(.enhanced)' ).each( function() {
            var select2_args = { minimumResultsForSearch: 5 };
            jQuery( this ).select2( select2_args ).addClass( 'enhanced' );
        });" );

        return $fields;

    }
    add_filter( 'woocommerce_checkout_fields', 'mipaquete_change_city_customer' );
    
    function mipaquete_shipping_method_init() {
        
        if ( ! class_exists( 'MIPAQUETE_Shipping_Method' ) ) {
            class MIPAQUETE_Shipping_Method extends WC_Shipping_Method {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */
                public function __construct( $instance_id = 0 ) {
                    $this->id                 = 'mipaquete_shipping_normal'; // Id for your shipping method. Should be uunique.
                    $this->method_title       = __( 'mipaquete envío normal' );  // Title shown in admin
                    $this->method_description = __( 'Envíos normales' ); // Description shown in admin
    
                    $this->enabled            = "yes"; // This can be added as an setting but for this example its forced enabled
                    $this->title              = "mipaquete.com envío "; // This can be added as an setting but for this example its forced.
    
                    $this->instance_id = absint( $instance_id );
    
                    $this->supports  = array(
                       'shipping-zones',
                        'instance-settings',
                        'instance-settings-modal',
                     );
    
                    $this->init();
                }
    
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */
                function init() {
                    // Load the settings API
                    $this->init_form_fields(); // This is part of the settings API. Override the method to add your own settings
                    $this->init_settings(); // This is part of the settings API. Loads settings you previously init.
                    
                    // Save settings in admin if you have any defined
                    add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
                }

                /////////////////////////////////////////////////
                ////////////////////////////////////////////////
                function init_form_fields() { 
 
                    $this->instance_form_fields = array(                        
                        'price_personalized' => array(
                            'title' => __( 'Configurar tarifa de envío personalizada', 'mipaquete' ),
                            'type' => 'number',
                            'description' => __( 'Entendemos que para facilitar procesos de venta algunas veces quieres configurar una única tarifa de envío, si deseas tener una tarifa estándar puedes hacerlo (Una vez generes el envío te cobraremos el valor real)', 'mipaquete' ),
                            'desc_tip' => true,
                        ),
                        'free_shipping' => array(
                            'title' => __('¿Deseas que los envíos sean gratuitos para el cliente?'),
                            'type'        => 'select',
                            'class'       => 'wc-enhanced-select',
                            'description' => __('Habilitar el envío gratis para mis clientes'),
                            'desc_tip' => true,
                            'options'     => array(
                                '0' => __('Selecciona opción'),
                                '2' => __('SI'),
                                '3' => __('NO')
                            )
                        ),
                        'free_shipping_cost_total' => array(
                            'title' => __( 'Envío gratuito a partir de un valor de venta en especifico(Debes tener habilitada la opción si, en envío gratuito)', 'mipaquete' ),
                            'type' => 'number',
                            'description' => __( 'Debes tener habilitada la opción si en el envío gratuito, por defecto el valor será cero ', 'mipaquete' ),
                            'desc_tip' => true,
                            'default'  => 0
                        ),
                    );
                }
                public function is_available( $package ){
                    return true;
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $packagect
                 * @return void
                 */
                public function calculate_shipping( $package = array() ) {
                    $value_select = get_option( 'mpq_value_select' );
                    $requestPickup = get_option( 'mpq_pickup' );
                    $price_personalized = $this->get_option( 'price_personalized' );
                    $free_shipping = $this->get_option( 'free_shipping' );
                    $free_shipping_cost_total = $this->get_option( 'free_shipping_cost_total' );
                    $url = get_url_api() . 'quoteShipping';
                    global $woocommerce, $post;
                    $items = $woocommerce->cart->get_cart();
                    $calculate_dimensions = calculate_dimensions($items);
                    $height = $calculate_dimensions['height'];
                    $width = $calculate_dimensions['width'];
                    $length = $calculate_dimensions['length'];
                    $weight = $calculate_dimensions['weight'];
                    $total_valorization = $calculate_dimensions['total_valorization'];
                    $city_destination  = $package['destination']['city'];
                    

                    
                    $quantity_cart = $woocommerce->cart->cart_contents_count;                    
                    foreach ($items as $item) {
                        $_product =  wc_get_product( $item['data']->get_id());
                        $_product_id = $_product->get_id();
                    }
                    
                    //Loop through each item from the cart
                    $customer = new WC_Customer(0, true);
                    $location = $customer->get_shipping_state();
                    $info_user_locationCode = return_get_user();
                    $data = array("originLocationCode" => "$info_user_locationCode[2]",
                    "destinyLocationCode" => "$city_destination",
                    "height" => $height,
                    "width" => $width,
                    "length" => $length,
                    "weight" => $weight,
                    "quantity" => 1,
                    "declaredValue" => $total_valorization,
                    "saleValue" => (int)$woocommerce->cart->total
                    );
                    
                    $apik = return_generate_apikey(get_option('mpq_email'), get_option('mpq_password'));
                    $data_string = json_encode($data);
                    var_dump($data_string);
                    $ch = curl_init($url);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type:application/json",
                    "session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c",
                    "apikey:" .$apik,  
                ));
                    
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

                    $result = curl_exec($ch);
                    $result_data = json_decode($result, true);
                    $total_data = (int)count($result_data);
                    curl_close($ch);
                    /* criterios de busqueda*/ 
                    
                    if (!empty($city_destination) && $value_select == 1 && $free_shipping != 2) {
                        array_multisort(array_column($result_data, 'shippingCost'), SORT_ASC, $result_data);
                    }
                    if (!empty($city_destination) && $value_select == 2 && $free_shipping != 2) {
                        array_multisort(array_column($result_data, 'shippingTime'), SORT_ASC, $result_data);   
                    }
                    
                    if (!empty($city_destination) && $value_select == 3 && $free_shipping != 2) {
                        array_multisort(array_column($result_data, 'score'), SORT_DESC, $result_data);   
                    }
                    $array_price_min = $result_data[0]['shippingCost'];
                    if ($price_personalized != '') {
                        $array_price_min = $price_personalized;
                    }            
                    var_dump($result_data);
                    if ($total_data > 0 && $free_shipping != 2) {
                        // Register the rate
                        $rate = array(
                            'id' => $this->id,
                            'label' => $this->title ,
                            'cost' => $array_price_min,
                            'calc_tax' => 'per_item'
                        );
                    }
                    elseif ($total_data > 0 && $free_shipping_cost_total == 0 || $free_shipping_cost_total == '' && $free_shipping == 2) {
                        $rate = array(
                            'id' => $this->id,
                            'label' => 'Envío gratis a través de mi paquete',
                            'calc_tax' => 'per_item'
                        );
                    }
                    elseif ($total_data > 0 && (int)$woocommerce->cart->total >= $free_shipping_cost_total && $free_shipping == 2) {
                        $rate = array(
                            'id' => $this->id,
                            'label' => 'Envío gratis a través de mi paquete',
                            'calc_tax' => 'per_item'
                        );
                    }
                    else {
                        $rate = "No hay métodos de envío disponibles";
                    }
                    
                    $this->add_rate( $rate );
                }   
            }
            
            
        }
        
        
        
        /***************************************************/
    
        if ( ! class_exists( 'MIPAQUETE_Shipping_Method_Upon_Delivery' ) ) {
            class MIPAQUETE_Shipping_Method_Upon_Delivery extends WC_Shipping_Method {
                /**
                 * Constructor for your shipping class
                 *
                 * @access public
                 * @return void
                 */
                public function __construct( $instance_id = 0 ) {
                    $this->id                 = 'mipaquete_shipping_upon_delivery'; // Id for your shipping method. Should be uunique.
                    $this->method_title       = __( 'mipaquete.com envío contraentrega' );  // Title shown in admin
                    $this->method_description = __( 'Envíos contraentrega' ); // Description shown in admin
    
                    $this->enabled            = "yes"; // This can be added as an setting but for this example its forced enabled
                    $this->title              = "mipaquete.com envío contraentrega"; // This can be added as an setting but for this example its forced.
    
                    $this->instance_id = absint( $instance_id );
    
                    $this->supports  = array(
                       'shipping-zones',
                        'instance-settings',
                        'instance-settings-modal',
                     );
    
                    $this->init();
                }
    
                /**
                 * Init your settings
                 *
                 * @access public
                 * @return void
                 */
                function init() {
                    // Load the settings API
                    $this->init_form_fields(); // This is part of the settings API. Override the method to add your own settings
                    $this->init_settings(); //   This is part of the settings API. Loads settings you previously init.
    
                    // Save settings in admin if you have any defined
                    add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
                }
                
                function init_form_fields() { 
 
                    $this->instance_form_fields = array(
                        'title_collection' => array(
                            'title'       => __( 'Nota' ),
                            'type'        => 'title',
                            'description' => __( 'Ten presente que para procesar tus envíos con pago contra entrega no necesitas tener saldo disponible, 
                            ya que del recaudo a realizar descontaremos el valor del envío. Esto aplica para todas las transportadoras excepto para ENVÍA y 
                            SERVIENTREGA, con las cuales si debes tener saldo disponible para procesar tus envíos.')  
                        ),
                    );
                }
                /**
                 * calculate_shipping function.
                 *
                 * @access public
                 * @param mixed $package
                 * @return void
                 */
                public function calculate_shipping( $package = array() ) {
                    $requestPickup1 = get_option( 'mpq_pickup' );
                    $value_selectUpon1 = get_option( 'mpq_value_select' );
                    $url1 = get_url_api() . 'quoteShipping';
                    global $woocommerce, $post;
                    $items1 = $woocommerce->cart->get_cart();
                    $calculate_dimensions1 = calculate_dimensions($items1);
                    $height1 = $calculate_dimensions1['height'];
                    $width1 = $calculate_dimensions1['width'];
                    $length1 = $calculate_dimensions1['length'];
                    $weight1 = $calculate_dimensions1['weight'];
                    $total_valorization1 = $calculate_dimensions1['total_valorization'];
                    $country1 = $package['destination']['country'];
                    $state_destination1 = $package['destination']['state'];
                    $city_destination1  = $package['destination']['city'];
                    $quantity_cart1 = $woocommerce->cart->cart_contents_count;
                    
                    foreach ($items1 as $item1) {
                        $_product1 =  wc_get_product( $item1['data']->get_id());
                    }
                    $_product_id1 = $_product1->get_id();
                    $customer1 = new WC_Customer(0, true);
                    $location1 = $customer1->get_shipping_state();
                    $info_user_locationCode1 = return_get_user();
                    $data1 = array("originLocationCode" => "$info_user_locationCode1[2]",
                    "destinyLocationCode" => "$city_destination1",
                    "height" => $height1,
                    "width" => $width1,
                    "length" => $length1,
                    "weight" => $weight1,
                    "quantity" => 1,
                    "declaredValue" => $total_valorization1,
                    "saleValue" => (int)$woocommerce->cart->total,
                );
                    $apik = return_generate_apikey(get_option('mpq_email'), get_option('mpq_password'));
                    $data_string1 = json_encode($data1);
                    
                    
                    $ch1 = curl_init($url1);
                    curl_setopt($ch1, CURLOPT_POSTFIELDS, $data_string1);
                    curl_setopt($ch1, CURLOPT_HTTPHEADER, array("Content-Type:application/json",
                    "session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c",
                    "apikey:" .$apik,
                ));

                    curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
                    $result1 = curl_exec($ch1);
                    $result_data1 = json_decode($result1, true);
                    $total_data1 = (int)count($result_data1);
                    curl_close($ch1);
                    //var_dump($result_data1);
                    /* criterios de busqueda*/ 
                    if (!empty($city_destination1) && $value_selectUpon1 == 1) {
                        array_multisort(array_column($result_data1, 'shippingCost'), SORT_ASC, $result_data1);
                    }
                    if (!empty($city_destination1) && $value_selectUpon1 == 2 ) {
                        array_multisort(array_column($result_data1, 'shippingTime'), SORT_ASC, $result_data1);   
                    }
                    
                    if (!empty($city_destination1) && $value_selectUpon1 == 3 ) {
                        array_multisort(array_column($result_data1, 'score'), SORT_DESC, $result_data1);   
                    }
                    if (!empty($result_data1[0]['collectionCommissionWithRate']) && $total_data1 > 0) {
                        $array_price_min1 = $result_data1[0]['shippingCost'] + $result_data1[0]['collectionCommissionWithRate'];
                        $rate = array(
                            'id' => $this->id,
                            'label' => $this->title,
                            'cost' => $array_price_min1,
                            'calc_tax' => 'per_item'
                        );
                    }
                    //var_dump($result_data1);
                    /*fin criterios de busqueda */
                    else {
                        $rate = "No hay métodos de envío disponibles";
                    }
                    
                    $this->add_rate( $rate );
                }
            }
        }
    
        /***************************************************/
    }
    
    add_action( 'woocommerce_shipping_init', 'mipaquete_shipping_method_init' );
    
    function mipaquete_shipping_method( $methods ) {
        
        $methods['mipaquete_shipping_normal'] = 'MIPAQUETE_Shipping_Method';
        $methods['mipaquete_shipping_upon_delivery'] = 'MIPAQUETE_Shipping_Method_Upon_Delivery';
        return $methods;
    }
    
    add_filter( 'woocommerce_shipping_methods', 'mipaquete_shipping_method' );
    //Declare the global WooCoomerce Object & Post Object

    function sending_mipaquete() {
        $info_user_sender = return_get_user();
        $apik = return_generate_apikey(get_option('mpq_email'), get_option('mpq_password'));
        
        $id_post = get_the_ID();
        $order = new WC_Order($id_post);
        $order_items = $order->get_items('shipping');
        foreach($order_items as $items_shipping){
            $shipping_method_id = $items_shipping['method_title'] ;
        }
        $order_data = $order->get_data(); // The Order data

        //sender//////
        $order_name = $info_user_sender[0];
        $order_phone = $info_user_sender[4];
        $order_email = $info_user_sender[3];
        $order_address = $info_user_sender[1];
        $order_nit = $info_user_sender[5];
        $order_niy_type = $info_user_sender[6];
        $order_location_code = $info_user_sender[2];
        $order_client_type = $info_user_sender[7];
        //sender///////

        //receiver//////////
        $receiver_name = $order_data['shipping']['first_name'] . " " . $order_data['shipping']['last_name'];
        $receiver_phone = $order_data['billing']['phone'];
        $receiver_email = $order_data['billing']['email'];
        $receiver_address = $order_data['shipping']['address_1'] . " " . $order_data['shipping']['address_2'];
        $receiver_nit = ".";
        $receiver_nit_type = "."; 
        $receiver_location_code = $order_data['shipping']['city'];
        $receiver_note = $order->get_customer_order_notes() ? $order->get_customer_order_notes() : $order->get_customer_note();
        if (empty($receiver_note)){
            $receiver_note = "N/A";
        }
        //receiver/////////

        /////product////////
        $total_sales= $order->get_total();
        ///////product///////
        if ( $order->has_status('mi-paquete') ) {
            $url = get_url_api() . 'createSending';
            $curl = curl_init($url);
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            $headers = array(
            "session-tracker: a0c96ea6-b22d-4fb7-a278-850678d5429c",
            "apikey:" .$apik,
            "Content-Type: application/json",
            );
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            ///////////////// product order //////////////////
            $items_order = $order->get_items();
            $calculate_dimensions_order = calculate_dimensions_order($items_order);
            $get_delivery_company_id = get_delivery_company_id($items_order,$receiver_location_code, $total_sales, $apik);
            
            $delivery_company_id = $get_delivery_company_id['deliveryCompanyId'];
            
            $width = $calculate_dimensions_order['width'];
            $height = $calculate_dimensions_order['height'];
            $length = $calculate_dimensions_order['length'];
            $weight = $calculate_dimensions_order['weight'];
            $total_valorization = $calculate_dimensions_order['total_valorization'];
            ///////////////// end product order //////////////
            
            if ( $shipping_method_id == 'mipaquete.com envío contraentrega' && $order->payment_method == 'cod') {
                $payment_type = 102;
            }
            elseif ($order_client_type == 'SaaS') {
                $payment_type = 105;
            }
            else {
                $payment_type = 101;
            }

            $value_collection = $shipping_method_id == 'mipaquete.com envío contraentrega' && $order->payment_method == 'cod' ? $total_sales : 0;
            $request_pickup = get_option('mpq_pickup') == '0' ? "true" : "false";
            $data = <<<DATA
            {
                "sender": {
                "name": "${order_name}",
                "surname": "N/A",
                "cellPhone": "${order_phone}",
                "prefix": "+57",
                "email": "${order_email}",
                "pickupAddress": "${order_address}",
                "nit": "${order_nit}",
                "nitType": "${order_niy_type}"
            },
            "receiver": {
                "name": "${receiver_name}",
                "surname": "N/A",
                "email": "${receiver_email}",
                "prefix": "+57",
                "cellPhone": "${receiver_phone}",
                "destinationAddress": "${receiver_address}",
                "nit": "${receiver_nit}",
                "nitType": "${receiver_nit_type}"
            },
            "productInformation": {
                "quantity": 1,
                "width": ${width},
                "large": ${length},
                "height": ${height},
                "weight": ${weight},
                "forbiddenProduct": true,
                "productReference": "-",
                "declaredValue": ${total_valorization}
            },
            "locate": {
                "originDaneCode": "${order_location_code}",
                "destinyDaneCode": "${receiver_location_code}"
            },
                "channel": "WOOCOMMERCEV2",
                "deliveryCompany": "${delivery_company_id}",
                "description": "N/A",
                "comments": "${receiver_note}",
                "paymentType": ${payment_type},
                "valueCollection": ${value_collection},
                "requestPickup": ${request_pickup} ,
                "adminTransactionData": {
                    "saleValue": ${total_sales}
                }
            }
            DATA;
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
            $resp = curl_exec($curl);
            $result_data_order = json_decode($resp, true);
            if ($result_data_order['message'] == 'Envio generado correctamente') {
                sleep(12);
                return_get_sending($result_data_order['mpCode'], $id_post);
                
            }
            elseif($result_data_order['message']['detail'] == 'there was an error in cash service') {
                $order->add_order_note(sprintf("Error <b style='color: red;'> No cuentas con saldo suficiente para realizar envíos, 
                por favor recarga tu cuenta y realiza nuevamente el envío. Código del error %s", $result_data_order['message']['code'] ."</b> Ingresa a tu perfil haciendo clic <a href='https://app.mipaquete.com/ingreso' target='_blank'>aquí</a> y haz tu recarga" ));
            }
            elseif(isset($result_data_order['message']['detail']['message'])){
                $order->add_order_note(sprintf("Hubo un error al generar el envío. <b style='color: red;'> Código del error  %s", $result_data_order['message']['code'] . " - " . $result_data_order['message']['detail']['message']  . " <br></b> 
                Comunícate a soporte@mipaquete.com con este código y te ayudaremos a solucionarlo, porfavor adjunta los pantallazos de la configuración del plugin, zonas de envío y de los productos que se encuentran en esta orden (medidas y peso). " ));
            }
            else {
                $order->add_order_note(sprintf("Hubo un error al generar el envío. <b style='color: red;'> Código del error  %s", $result_data_order['message']['code'] . "-" . $result_data_order['message']['detail']  . " <br></b> 
                Comunícate a soporte@mipaquete.com con este código y te ayudaremos a solucionarlo, porfavor adjunta los pantallazos de la configuración del plugin, zonas de envío y de los productos que se encuentran en esta orden (medidas y peso). " ));
                
            }
        }
        
        
    }    
      
    //add_action( 'admin_notices' , 'sending_mipaquete'); 
    add_action( 'woocommerce_order_status_changed' , 'sending_mipaquete'); 
}
?>