<?php
function get_url_api(){
    $url_apiv2 = get_option('mpq_enviroment') == 0 ? 'https://api-v2.mpr.mipaquete.com/' : 'https://api-v2.dev.mpr.mipaquete.com/';
    return $url_apiv2;
}
 
function general_admin_notice(){
    global $pagenow;
    if ( $pagenow == 'options.php' ) {
         echo '<div class="notice notice-warning is-dismissible">
             <p>Se guardo la configuración</p>
         </div>';
    }
}

if (!function_exists('mpq_options_page')){
    function mpq_options_page(){
        add_menu_page(
            'Mipaquete configuración',
            'Mipaquete configuración',
            'manage_options',
            'mpq_options_shipping',
            'mpq_options_shipping_page_display',
            plugin_dir_url( __FILE__ ) . 'img/icon-mipaquete.png',
            15,
        );
    }
    add_action('admin_menu', 'mpq_options_page');
    add_action('admin_init', 'mpq_admin_init');
}


if (!function_exists('mpq_admin_init')){
    function mpq_admin_init(){
        register_setting( 'mpq_options_group', 'mpq_email' );
        register_setting( 'mpq_options_group', 'mpq_password' );
        register_setting( 'mpq_options_group', 'mpq_enviroment' );
        register_setting( 'mpq_options_group', 'mpq_value_select' );
        register_setting( 'mpq_options_group', 'mpq_pickup' );        
    }   
}

if (!function_exists('mpq_options_shipping_page_display')){
    function mpq_options_shipping_page_display(){
        $info_user = return_get_user();
        
        
?>
    <div class="wrap">
        <form action="options.php" method="POST" >
            <?php settings_fields( 'mpq_options_group');
                wp_enqueue_style( 'my-style-mpq', plugins_url( '/css/style.css', __FILE__ ), false, '1.0', 'all' ); // Inside a plugin
            ?>
            
            <center>
                <img class="img" src="https://mipaquete.com/img/banner-wp.png" style="width:100%;">
                
                <h3>Tus datos</h3>
                
                <div id="contenedor">
                    <div id="contenidos">
                        <div id="columna1">
                            <span class="mpq" style="margin:auto 0px; position:absolute;" >Nombre: </span>
                        </div>
                        <div id="columna2" class="right mpq" style="margin:auto 370px; position:absolute;" >
                            <?php 
                                if (($info_user[0]) != '') {
                                    echo $info_user[0] ." - ". $info_user[7];
                                }
                                else {
                                    echo "No se encontraron datos, verifique el usuario y contraseña";
                                }  
                            ?>
                            
                        </div>
                    </div>
                    <br>
                    <div id="contenidos">
                        <div id="columna1">
                            <span class="mpq" style="margin:auto 0px; position:absolute;">Dirección de recogida: </span>
                        </div>
                        <div id="columna2" class="righ mpq" style="margin:auto 370px; position:absolute;"  >
                        <?php 
                                if (!is_null($info_user[1])) {
                                    echo $info_user[1];
                                }
                                else {
                                    echo "No se encontraron datos, verifique el usuario y contraseña";
                                }  
                            ?>
                        </div>
                    </div>
                </div> 

                <div id="contenedor">
                    <div id="contenidos">
                        <div id="columna1">
                            <label name="mpq_email" id="mpq_email" class="mpq" >Email</label>
                        </div>
                        <div id="columna2">
                            <input type="email" name="mpq_email" name="mpq_email" class="input" placeholder="email" value=<?php echo get_option('mpq_email') ?>>
                            <br>
                            Correo con el que te registraste en mipaquete
                        </div>
                        
                    </div>
                    
                    <div id="contenidos">
                        <div id="columna1">
                            <label name="mpq_password" id="mpq_password" class="mpq" >Contraseña</label>
                        </div>
                        <div id="columna2">
                            <input type="password" name="mpq_password" id="mpq_password" class="input" placeholder="contraseña" value=<?php echo get_option('mpq_password') ?>>
                            <br>
                            Contraseña con la que te registraste en mipaquete
                        </div>
                    </div>

                    <div id="contenidos">
                        <div id="columna1">
                            <label name="mpq_pickup" id="mpq_pickup" class="mpq" >Deseo llevar mis paquetes a una oficina cercana</label>
                        </div>
                        <div id="columna2">
                            <select name="mpq_pickup" id="mpq_pickup" class="input" >
                            <?php 
                                if (get_option('mpq_pickup') == 0) {
                                    $value_pickup = "NO";
                                }
                                else {
                                    $value_pickup = "SI";
                                }
                            ?>
                                <option value="<?php echo get_option('mpq_pickup');?>">Valor actual: <b><?php echo $value_pickup; ?></b></option>   
                                <option value="0">NO</option>
                                <option value="1">SI</option>
                            </select>
                        </div>
                    </div>

                    <div id="contenidos">
                        <div id="columna1">
                            <label name="mpq_enviroment" id="mpq_enviroment" class="mpq" >¿Deseas habilitar el ambiente de pruebas?</label>
                        </div>
                        <div id="columna2">
                            <select name="mpq_enviroment" id="mpq_enviroment" class="input" >
                            <?php 
                                if (get_option('mpq_enviroment') == 0) {
                                    $value_enviroment = "NO";
                                }
                                else {
                                    $value_enviroment = "SI";
                                }
                            ?>
                                <option value="<?php echo get_option('mpq_enviroment');?>">Valor actual: <b><?php echo $value_enviroment?></b></option>   
                                <option value="0">NO</option>
                                <option value="1">SI</option>
                            </select>
                        </div>
                    </div>
                    <div id="contenidos">
                        <div id="columna1">
                            <label name="mpq_value_select" id="mpq_value_select" class="mpq" >Escoge el criterio de busqueda de la transportadora </label>
                        </div>
                        <div id="columna2">
                        <select name="mpq_value_select" id="mpq_value_select" class="input" >
                            
                            <?php 
                                if (get_option('mpq_value_select') == 1) {
                                    $value_actual = "Más económica";
                                }
                                else if(get_option('mpq_value_select') == 2) {
                                    $value_actual = "Menor tiempo de entrega";
                                }
                                else {
                                    $value_actual = "Mejor calificación del servicio";
                                }
                            ?>
                            <option value="<?php echo get_option('mpq_value_select');?>">Valor actual: <b><?php echo $value_actual?></b></option>
                            <option value="1">Más económica</option>    
                            <option value="2">Menor tiempo de entrega</option>
                            <option value="3">Mejor calificación del servicio</option>
                        </select>
                        <br>
                        
                        </div>
                    </div>
                </div>  
                                  

                <?php @submit_button('Conectar'); ?>
                <br>
                <b>Aún no tienes tu cuenta en mipaquete.com? Regístrate aquí:</b> <a href="https://app.mipaquete.com/registro" target="_blank">https://app.mipaquete.com/registro</a></b><br><br>
                <b>Configurar nuestro plugin de envíos es muy fácil, conoce el paso a paso en: </b> <a href="https://mipaquete.com/plugin/" target="_blank">https://mipaquete.com/plugin/</a></b>
                <br><br>
                <b>Si deseas realizar pruebas primero, registrate en esta url <a href="https://app.dev.mpr.mipaquete.com/registro" target="_blank">https://app.dev.mpr.mipaquete.com/registro</a>
                <br>Una vez lo hayas hecho escríbenos a soporte@mipaquete.com con el correo que te registraste y procederemos a asignarte un saldo para que hagas pruebas.</b>    
            </center> 
        </form>
    </div>
    <?php
        
    }
    
}

function return_generate_apikey($email, $password) {
    $url_generate_api_key = get_url_api() . 'generateapikey';
    $data_generate_api_key = array("email" => $email, "password" => $password);
    $data_string_generate_api_key = json_encode($data_generate_api_key);
    $ch_generate_api_key = curl_init($url_generate_api_key);
    curl_setopt($ch_generate_api_key, CURLOPT_POSTFIELDS, $data_string_generate_api_key);
    curl_setopt($ch_generate_api_key, CURLOPT_HTTPHEADER, array('Content-Type:application/json',
        'session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c',
    ));
    curl_setopt($ch_generate_api_key, CURLOPT_RETURNTRANSFER, true);
    $result_generate_api_key = curl_exec($ch_generate_api_key);
    $result_data_generate_api_key = json_decode($result_generate_api_key, true);
    return $result_data_generate_api_key['APIKey'];
}

function return_get_user() {
    $apikey_config = return_generate_apikey(get_option('mpq_email'), get_option('mpq_password'));
    $url = get_url_api() . 'getUser';

    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true); 
    curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type:application/json',
        'session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c',
        'apikey:' . $apikey_config,
    )); 
    $result_getUser = curl_exec($curl);
    curl_close($curl);
    $result_getUser_json = json_decode($result_getUser, true);
    $name = $result_getUser_json['name'] . " " . $result_getUser_json['surname']; 
    $address = $result_getUser_json['address']; 
    $locationCode = $result_getUser_json['locationCode'];
    $email = $result_getUser_json['email'];
    $cellPhone = $result_getUser_json['cellPhone'];
    $documentNumber = $result_getUser_json['documentNumber'];
    $documentType = $result_getUser_json['documentType'];
    if ($result_getUser_json['clientType'] == "SaaS" ) {
        $clientType = $result_getUser_json['clientType'];
    }
    else {
        $clientType = 'Usuario Mipaquete';
    }
    return array($name, $address, $locationCode, $email, $cellPhone, $documentNumber, $documentType, $clientType);
}

function return_get_sending($mp_code, $order) {
    $apikey_config = return_generate_apikey(get_option('mpq_email'), get_option('mpq_password'));
    $url = get_url_api() . 'getSendings/1';

    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true); 
    $data = <<<DATA
    {
        "pageSize": 1,
        "mpCode": ${mp_code}
    }
    DATA;
    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type:application/json',
        'session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c',
        'apikey:' . $apikey_config,
    )); 
    $result_getSending = curl_exec($curl);
    curl_close($curl);
    $order = new WC_Order($order);
    
    $result_getSending_json = json_decode($result_getSending, true);
    $code_mp = $result_getSending_json['sendings'][0]['Código mipaquete']; 
    $guide_number = $result_getSending_json['sendings'][0]['Número de Guía']; 
    $delivery_company = $result_getSending_json['sendings'][0]['Transportadora']; 
    
    if (isset($result_getSending_json['sendings'][0]['pdfGuide'][0])) {
        $pdf_guide = $result_getSending_json['sendings'][0]['pdfGuide'][0];
    } 
    if (isset($result_getSending_json['sendings'][0]['pdfGuide'][1])) {
        $pdf_relation = $result_getSending_json['sendings'][0]['pdfGuide'][1];
    }

    $details_shipping = "Los detalles de tu envío son los siguientes:<br>";
    $details_shipping .=  "Código de mipaquete es: " . $code_mp . "<br>";
    $details_shipping .=  "La guía es: " . $guide_number . "<br>";
    $details_shipping .=  "La transportadora es: " . $delivery_company . "<br>";
    
    $details_shipping .= isset($pdf_guide) ? "Descarga la guía  <a href='" . $pdf_guide ."' target='_blank'>aquí</a>" : "No se generó la guía de envío";
    $details_shipping .= isset($pdf_relation) ? "<br>Descarga la relación de envío  <a href='" . $pdf_relation . "' target='_blank'>aquí</a>" : "<br>No tiene relación de envío";
    $order->add_order_note(sprintf("<b> %s  ", $details_shipping. "</b>" ));

}

function return_get_locations($shipping_city) {
    
    $info_user_locationCode = return_get_user();
    $apikey_config = return_generate_apikey(get_option('mpq_email'), get_option('mpq_password'));
    $url = get_url_api() . 'getLocations?locationCode=' . $shipping_city;
    //echo $url;
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true); 
    curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type:application/json',
        'session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c',
        'apikey:' . $apikey_config,
    )); 
    $result_getLocation = curl_exec($curl);
    curl_close($curl);
    $result_getLocation_json = json_decode($result_getLocation, true);
    $name_city = $result_getLocation_json[0]['locationName'];
    $name_state = $result_getLocation_json[0]['departmentOrStateName'];
    $location_code_city = $result_getLocation_json[0]['locationCode'];

    return array($name_city, $name_state, $location_code_city);
}

function get_delivery_company_id($items_order, $city_destination_order, $sale_value, $apikey ){
    global $woocommerce;
    $value_select = get_option( 'mpq_value_select' );
    $free_shipping = get_option( 'free_shipping' );
    $url = get_url_api() . 'quoteShipping';
    $calculate_dimensions = calculate_dimensions($items_order);
    $height = $calculate_dimensions['height'];
    $width = $calculate_dimensions['width'];
    $length = $calculate_dimensions['length'];
    $weight = $calculate_dimensions['weight'];
    $total_valorization = $calculate_dimensions['total_valorization'];
    $city_destination  = $city_destination_order;
    
    $quantity_cart = 1;                    
    foreach ($items_order as $item => $values) {
        $_product_id = $values['product_id'] ?? $values->get_product_id();
        $_product = wc_get_product( $_product_id );
        $quantity = $values['quantity'];
    }
    
    //Loop through each item from the cart
    $customer = new WC_Customer(0, true);
    $location = $customer->get_shipping_state();
    $info_user_locationCode = return_get_user();
    $data = array("originLocationCode" => "$info_user_locationCode[2]",
    "destinyLocationCode" => "$city_destination",
    "height" => (int)$height,
    "width" => (int)$width,
    "length" => (int)$length,
    "weight" => (int)$weight,
    "quantity" => 1,
    "declaredValue" => (int)$total_valorization,
    "saleValue" => (int)$sale_value,
    );
    
    $data_string = json_encode($data);

    
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type:application/json",
    "session-tracker:a0c96ea6-b22d-4fb7-a278-850678d5429c",
    "apikey:" .$apikey,  
));
    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $result = curl_exec($ch);
    $result_data = json_decode($result, true);
    $total_data = (int)count($result_data);
    //var_dump($result_data);
    curl_close($ch);
    if (!empty($city_destination) && $value_select == 1 && $free_shipping != 2) {
        array_multisort(array_column($result_data, 'shippingCost'), SORT_ASC, $result_data);
    }
    if (!empty($city_destination) && $value_select == 2 && $free_shipping != 2) {
        array_multisort(array_column($result_data, 'shippingTime'), SORT_ASC, $result_data);   
    }
    
    if (!empty($city_destination) && $value_select == 3 && $free_shipping != 2) {
        array_multisort(array_column($result_data, 'score'), SORT_DESC, $result_data);   
    }
    //var_dump($data_string);
    $order_get_delivery_company_id = $result_data[0]['deliveryCompanyId'];
    //echo "deliveryy" . $order_get_delivery_company_id;

    return array('deliveryCompanyId' => $order_get_delivery_company_id);
}

add_action( 'init', function() {
register_post_status( 'wc-mi-paquete', array(
    'label'                     => 'Generar envíos con mipaquete.com (Este proceso tarda entre 30 y 60 segundos, no recargues la página)',
    'public'                    => true,
    'exclude_from_search'       => false,
    'show_in_admin_all_list'    => true,
    'show_in_admin_status_list' => true,
    'label_count'               => _n_noop( 'Envios generados a traves de mipaquete.com <span class="count">(%s)</span>', 'Envios generados a través de mipaquete.com <span class="count">(%s)</span>'),
) );
}, 10 );
    
add_filter ( 'wc_order_statuses', function( $estados ) {
$estados['wc-mi-paquete'] = 'Generar envíos con mipaquete.com (Este proceso tarda entre 30 y 60 segundos, no recargues la página)';
return $estados;
}, 10, 1 );

function calculate_dimensions($items) {
    $height = 0;
    $length = 0;
    $weight = 0;
    $width = 0;
    $total_valorization = 0;

    foreach ( $items as $item => $values ) {
        if ($values['variation_id'] != 0 && $values['product_id'] != 0) {
            $_product_id = $values['variation_id'];
        }
        elseif ($values['variation_id'] == 0 && $values['product_id'] != 0) {
            $_product_id = $values['product_id'];
        }
        elseif ($values['variation_id'] != 0 && $values['product_id'] == 0) {
            $_product_id = $values['variation_id'];
        }
        else {
            $_product_id = 0;
        }
        //echo "product id" . $_product_id;
        $_product = wc_get_product( $_product_id );
        $quantity = $values['quantity'];
        $declared_value = 0;

        if ($_product->is_type( 'variable' )) {
            $variations = $_product->get_available_variations();
            $variations_total_data = (int)count($variations);
            for ($i=0; $i < $variations_total_data; $i++) { 
                $height += ceil($variations[$i]['dimensions']['height'] * $quantity);
                $length = ceil($variations[$i]['dimensions']['length'] > $length ? $variations[$i]['dimensions']['length'] : $length);
                $weight =+ ceil($weight + ($variations[$i]['weight'] * $quantity));
                $width =  ceil($variations[$i]['dimensions']['width'] > $width ? $variations[$i]['dimensions']['width'] : $width);
                $declared_value += $variations[$i]['display_price'];
                $total_valorization = $declared_value > 10000 ? $declared_value : 10000;
                
            }
        }
        
        if ( !$_product->get_weight() || !$_product->get_length() 
            || !$_product->get_width() || !$_product->get_height() 
            || $height > 200 || $width > 200 || $length > 200 || $weight > 150 )
            break;
        
        $custom_price_product = get_post_meta($_product_id, '_custom_product_number_field_mipaquete', true);
        $total_valorization += $custom_price_product ? $custom_price_product : $_product->get_price();

        $total_valorization = $total_valorization * $quantity;

        if ($total_valorization < 10000) {
            $total_valorization = 10000;
        }
        $height += ceil($_product->get_height() * $quantity);
        $length = ceil($_product->get_length() > $length ? $_product->get_length() : $length);
        $weight =+ ceil($weight + ($_product->get_weight() * $quantity));
        $width =  ceil($_product->get_width() > $width ? $_product->get_width() : $width);
    }
    return array(
        'height' => $height,
        'length' => $length,
        'weight' => $weight,
        'width' =>  $width,
        'total_valorization' => $total_valorization
    );
}
////////////////// calculate order /////////////////////////////////
function calculate_dimensions_order($items) {
    $height = 0;
    $length = 0;
    $weight = 0;
    $width = 0;
    $total_valorization = 0;

    foreach ( $items as $item => $values ) {
        if ($values['variation_id'] != 0 && $values['product_id'] != 0) {
            $_product_id = $values['variation_id'];
        }
        elseif ($values['variation_id'] == 0 && $values['product_id'] != 0) {
            $_product_id = $values['product_id'];
        }
        elseif ($values['variation_id'] != 0 && $values['product_id'] == 0) {
            $_product_id = $values['variation_id'];
        }
        else {
            $_product_id = 0;
        }
        //echo "product id" . $_product_id;
        $_product = wc_get_product( $_product_id );
        $quantity = $values['quantity'];
        $declared_value = 10000;

        if ($_product->is_type( 'variable' )) {
            $variations = $_product->get_available_variations();
            $variations_total_data = (int)count($variations);
            for ($i=0; $i < $variations_total_data; $i++) { 
                $height += ceil($variations[$i]['dimensions']['height'] * $quantity);
                $length = ceil($variations[$i]['dimensions']['length'] > $length ? $variations[$i]['dimensions']['length'] : $length);
                $weight =+ ceil($weight + ($variations[$i]['weight'] * $quantity));
                $width =  ceil($variations[$i]['dimensions']['width'] > $width ? $variations[$i]['dimensions']['width'] : $width);
                $declared_value += $variations[$i]['display_price'];
                $total_valorization = $declared_value > 10000 ? $declared_value : 10000;
                
            }

        }
        
        if ( !$_product->get_weight() || !$_product->get_length() 
            || !$_product->get_width() || !$_product->get_height() 
            || $height > 200 || $width > 200 || $length > 200 || $weight > 150 )
            break;
        
        $custom_price_product = get_post_meta($_product_id, '_custom_product_number_field_mipaquete', true);
        $total_valorization += $custom_price_product ? $custom_price_product : $_product->get_price();

        $total_valorization = $total_valorization * $quantity;

        if ($total_valorization < 10000) {
            $total_valorization = 10000;
        }
        $height += ceil($_product->get_height() * $quantity);
        $length = ceil($_product->get_length() > $length ? $_product->get_length() : $length);
        $weight =+ ceil($weight + ($_product->get_weight() * $quantity));
        $width =  ceil($_product->get_width() > $width ? $_product->get_width() : $width);
    }
    return array(
        'height' => $height,
        'length' => $length,
        'weight' => $weight,
        'width' =>  $width,
        'total_valorization' => $total_valorization
    );
}
////////////////////////////////////////////////////////////////////
// Remove "shipping" section from cart page only
add_filter( 'woocommerce_cart_needs_shipping', 'filter_cart_needs_shipping' );
function filter_cart_needs_shipping( $needs_shipping ) {
    return is_cart() ? false : $needs_shipping;
}

// Add a custom shipping message row
add_action( 'woocommerce_cart_totals_before_order_total', 'cart_custom_shipping_message_row' );
function cart_custom_shipping_message_row() {
    if ( ! WC()->cart->needs_shipping() ) :

    $shipping_message = __("Calcula tu envío al finalizar la compra.", "woocommerce");
    ?>
    <tr class="shipping">
        <th><?php _e( 'Shipping', 'woocommerce' ); ?></th>
        <td class="message" data-title="<?php esc_attr_e( 'Shipping', 'woocommerce' ); ?>"><em><?php echo $shipping_message; ?></em></td>
    </tr>
    <?php endif;
}


// Display "Verification ID" on Admin order edit page
add_action( 'woocommerce_admin_order_data_after_billing_address', 'display_order_mipaquete_meta', 10, 1 );
function display_order_mipaquete_meta( $order ) {
    // get data location
    $location_code = return_get_locations($order->get_billing_city());
    $city_mipaquete = $location_code[0];
    $state_mipaquete = $location_code[1];
    // compatibility with WC +3
    $order_id = method_exists( $order, 'get_id' ) ? $order->get_id() : $order->id;
    echo '<p><strong>'.__('Ciudad', 'woocommerce').':</strong> ' . $city_mipaquete . '</p>';
    echo '<p><strong>'.__('Departamento', 'woocommerce').':</strong> ' . $state_mipaquete . '</p>';
}
?>